"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleHardforkResult = exports.getHasSeenHF191 = exports.getHasSeenHF190 = exports.resetHardForkCachedValues = void 0;
const lodash_1 = require("lodash");
const channelsItem_1 = require("../../../data/channelsItem");
let hasSeenHardfork190;
let hasSeenHardfork191;
function resetHardForkCachedValues() {
    hasSeenHardfork190 = hasSeenHardfork191 = undefined;
}
exports.resetHardForkCachedValues = resetHardForkCachedValues;
async function getHasSeenHF190() {
    if (hasSeenHardfork190 === undefined) {
        const oldHhasSeenHardfork190 = (await (0, channelsItem_1.getItemById)('hasSeenHardfork190'))?.value;
        if (oldHhasSeenHardfork190 === undefined) {
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork190', value: false });
            hasSeenHardfork190 = false;
        }
        else {
            hasSeenHardfork190 = oldHhasSeenHardfork190;
        }
    }
    return hasSeenHardfork190;
}
exports.getHasSeenHF190 = getHasSeenHF190;
async function getHasSeenHF191() {
    if (hasSeenHardfork191 === undefined) {
        const oldHhasSeenHardfork191 = (await (0, channelsItem_1.getItemById)('hasSeenHardfork191'))?.value;
        if (oldHhasSeenHardfork191 === undefined) {
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork191', value: false });
            hasSeenHardfork191 = false;
        }
        else {
            hasSeenHardfork191 = oldHhasSeenHardfork191;
        }
    }
    return hasSeenHardfork191;
}
exports.getHasSeenHF191 = getHasSeenHF191;
async function handleHardforkResult(json) {
    if (hasSeenHardfork190 === undefined || hasSeenHardfork191 === undefined) {
        const oldHhasSeenHardfork190 = (await (0, channelsItem_1.getItemById)('hasSeenHardfork190'))?.value;
        const oldHasSeenHardfork191 = (await (0, channelsItem_1.getItemById)('hasSeenHardfork191'))?.value;
        if (oldHhasSeenHardfork190 === undefined) {
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork190', value: false });
            hasSeenHardfork190 = false;
        }
        else {
            hasSeenHardfork190 = oldHhasSeenHardfork190;
        }
        if (oldHasSeenHardfork191 === undefined) {
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork191', value: false });
            hasSeenHardfork191 = false;
        }
        else {
            hasSeenHardfork191 = oldHasSeenHardfork191;
        }
    }
    if (hasSeenHardfork191 && hasSeenHardfork190) {
        window.log.info('hardfork 19.1 already happened. No need to go any further');
        return;
    }
    if (json?.hf &&
        Array.isArray(json.hf) &&
        json.hf.length === 2 &&
        (0, lodash_1.isNumber)(json.hf[0]) &&
        (0, lodash_1.isNumber)(json.hf[1])) {
        if (!hasSeenHardfork190 && json.hf[0] >= 19 && json.hf[1] >= 0) {
            window.log.info('[HF]: We just detected HF 19.0 on "retrieve"');
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork190', value: true });
            hasSeenHardfork190 = true;
        }
        if (!hasSeenHardfork191 && json.hf[0] >= 19 && json.hf[1] >= 1) {
            window.log.info('[HF]: We just detected HF 19.1 on "retrieve"');
            await (0, channelsItem_1.createOrUpdateItem)({ id: 'hasSeenHardfork191', value: true });
            hasSeenHardfork191 = true;
        }
    }
}
exports.handleHardforkResult = handleHardforkResult;
