"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatScrollButton = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const styled_components_1 = __importDefault(require("styled-components"));
const conversations_1 = require("../state/selectors/conversations");
const icon_1 = require("./icon");
const BchatScrollButtonDiv = styled_components_1.default.div `
  position: fixed;
  z-index: 2;
  right: 26px;
  animation: fadein var(--default-duration);
  bottom: 72px;
`;
const BchatScrollButton = (props) => {
    const show = (0, react_redux_1.useSelector)(conversations_1.getShowScrollButton);
    return (react_1.default.createElement(BchatScrollButtonDiv, null,
        react_1.default.createElement("div", { className: 'downArrow' },
            react_1.default.createElement(icon_1.BchatIconButton, { iconType: "arrow", iconSize: 18, isHidden: !show, iconColor: 'var(--color-downArrow)', onClick: props.onClickScrollBottom, dataTestId: "scroll-to-bottom-button" }),
            react_1.default.createElement("div", { className: 'downArrow-unreadCountBox' }, props.unreadCount))));
};
exports.BchatScrollButton = BchatScrollButton;
