"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainViewController = exports.MessageView = void 0;
const react_1 = __importDefault(require("react"));
const utils_1 = require("../bchat/utils");
const closedGroups_1 = require("../receiver/closedGroups");
const constants_1 = require("../bchat/constants");
class MessageView extends react_1.default.Component {
    render() {
        return (react_1.default.createElement("div", { className: "conversation placeholder" },
            react_1.default.createElement("div", { className: "conversation-header" }),
            react_1.default.createElement("div", { className: "container" },
                react_1.default.createElement("div", { className: "content bchat-full-logo" },
                    react_1.default.createElement("div", { className: "bchat-text-logo" },
                        react_1.default.createElement("p", { className: "bchat-text" },
                            "Much empty. Such wow.",
                            react_1.default.createElement("br", null),
                            " Get some friends to BChat!"))))));
    }
}
exports.MessageView = MessageView;
async function createClosedGroup(groupName, groupMemberIds) {
    if (groupName.length === 0) {
        utils_1.ToastUtils.pushToastError('invalidGroupName', window.i18n('invalidGroupNameTooShort'));
        return false;
    }
    else if (groupName.length > constants_1.VALIDATION.MAX_GROUP_NAME_LENGTH) {
        utils_1.ToastUtils.pushToastError('invalidGroupName', window.i18n('invalidGroupNameTooLong'));
        return false;
    }
    if (groupMemberIds.length < 1) {
        utils_1.ToastUtils.pushToastError('pickSecretGroupMember', window.i18n('pickSecretGroupMember'));
        return false;
    }
    else if (groupMemberIds.length >= constants_1.VALIDATION.CLOSED_GROUP_SIZE_LIMIT) {
        utils_1.ToastUtils.pushToastError('secretGroupMaxSize', window.i18n('secretGroupMaxSize'));
        return false;
    }
    await (0, closedGroups_1.createClosedGroup)(groupName, groupMemberIds);
    return true;
}
exports.MainViewController = {
    createClosedGroup,
};
