"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemberListItem = void 0;
const react_1 = __importDefault(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const Avatar_1 = require("./avatar/Avatar");
const bchat_1 = require("../bchat");
const icon_1 = require("./icon");
const useParamSelector_1 = require("../hooks/useParamSelector");
const styled_components_1 = __importDefault(require("styled-components"));
const AvatarContainer = styled_components_1.default.div `
  position: relative;
`;
const AvatarItem = (props) => {
    const { memberPubkey, isAdmin } = props;
    return (react_1.default.createElement(AvatarContainer, null,
        react_1.default.createElement(Avatar_1.Avatar, { size: Avatar_1.AvatarSize.M, pubkey: memberPubkey }),
        isAdmin && react_1.default.createElement(Avatar_1.CrownIcon, null)));
};
const MemberListItem = (props) => {
    const { isSelected, pubkey, isZombie, isAdmin, onSelect, onUnselect, disableBg, dataTestId, } = props;
    const memberName = (0, useParamSelector_1.useConversationUsernameOrShorten)(pubkey);
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)('bchat-member-item', isSelected && 'selected', isZombie && 'zombie', disableBg && 'compact'), onClick: () => {
            isSelected ? onUnselect?.(pubkey) : onSelect?.(pubkey);
        }, style: !disableBg
            ? {}
            : {}, role: "button", "data-testid": dataTestId },
        react_1.default.createElement("div", { className: "bchat-member-item__info", style: { width: "100%" } },
            react_1.default.createElement("span", { className: "bchat-member-item__avatar" },
                react_1.default.createElement(AvatarItem, { memberPubkey: pubkey, isAdmin: isAdmin || false })),
            react_1.default.createElement("span", { className: "bchat-member-item__name" }, memberName)),
        react_1.default.createElement("span", { className: (0, classnames_1.default)('bchat-member-item__checkmark', isSelected && 'selected') }, isSelected && react_1.default.createElement(icon_1.BchatIcon, { iconType: "circle", iconSize: "medium", iconColor: bchat_1.Constants.UI.COLORS.GREEN }))));
};
exports.MemberListItem = MemberListItem;
