"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClosedGroupAvatar = void 0;
const react_1 = __importDefault(require("react"));
const useMembersAvatars_1 = require("../../../hooks/useMembersAvatars");
const Avatar_1 = require("../Avatar");
function getClosedGroupAvatarsSize(size) {
    switch (size) {
        case Avatar_1.AvatarSize.S:
            return Avatar_1.AvatarSize.XS;
        case Avatar_1.AvatarSize.M:
            return Avatar_1.AvatarSize.S;
        case Avatar_1.AvatarSize.L:
            return Avatar_1.AvatarSize.M;
        case Avatar_1.AvatarSize.XL:
            return Avatar_1.AvatarSize.L;
        case Avatar_1.AvatarSize.HUGE:
            return Avatar_1.AvatarSize.XL;
        default:
            throw new Error(`Invalid size request for closed group avatar: ${size}`);
    }
}
const ClosedGroupAvatar = (props) => {
    const { closedGroupId, size, onAvatarClick } = props;
    const memberAvatars = (0, useMembersAvatars_1.useMembersAvatars)(closedGroupId);
    const avatarsDiameter = getClosedGroupAvatarsSize(size);
    const firstMemberId = memberAvatars?.[0];
    const secondMemberID = memberAvatars?.[1];
    return (react_1.default.createElement("div", { className: "module-avatar__icon-closed" },
        react_1.default.createElement(Avatar_1.Avatar, { size: avatarsDiameter, pubkey: firstMemberId || '', onAvatarClick: onAvatarClick }),
        react_1.default.createElement(Avatar_1.Avatar, { size: avatarsDiameter, pubkey: secondMemberID || '', onAvatarClick: onAvatarClick })));
};
exports.ClosedGroupAvatar = ClosedGroupAvatar;
