"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallWindowControls = exports.HangUpButton = exports.AudioOutputButton = exports.AudioInputButton = exports.VideoInputButton = void 0;
const icon_1 = require("../icon");
const react_contexify_1 = require("react-contexify");
const call_1 = require("../../state/ducks/call");
const utils_1 = require("../../bchat/utils");
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const call_2 = require("../../state/selectors/call");
const DropDownAndToggleButton_1 = require("../icon/DropDownAndToggleButton");
const styled_components_1 = __importDefault(require("styled-components"));
const videoTriggerId = 'video-menu-trigger-id';
const audioTriggerId = 'audio-menu-trigger-id';
const audioOutputTriggerId = 'audio-output-menu-trigger-id';
const VideoInputButton = ({ currentConnectedCameras, localStreamVideoIsMuted, hideArrowIcon = false, }) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(DropDownAndToggleButton_1.DropDownAndToggleButton, { iconType: "camera", isMuted: localStreamVideoIsMuted, onMainButtonClick: () => {
                void handleCameraToggle(currentConnectedCameras, localStreamVideoIsMuted);
            }, onArrowClick: e => {
                showVideoInputMenu(currentConnectedCameras, e);
            }, hidePopoverArrow: hideArrowIcon }),
        react_1.default.createElement(VideoInputMenu, { triggerId: videoTriggerId, camerasList: currentConnectedCameras })));
};
exports.VideoInputButton = VideoInputButton;
const AudioInputButton = ({ currentConnectedAudioInputs, isAudioMuted, hideArrowIcon = false, }) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(DropDownAndToggleButton_1.DropDownAndToggleButton, { iconType: "microphone", isMuted: isAudioMuted, onMainButtonClick: () => {
                void handleMicrophoneToggle(currentConnectedAudioInputs, isAudioMuted);
            }, onArrowClick: e => {
                showAudioInputMenu(currentConnectedAudioInputs, e);
            }, hidePopoverArrow: hideArrowIcon }),
        react_1.default.createElement(AudioInputMenu, { triggerId: audioTriggerId, audioInputsList: currentConnectedAudioInputs })));
};
exports.AudioInputButton = AudioInputButton;
const AudioOutputButton = ({ currentConnectedAudioOutputs, isAudioOutputMuted, hideArrowIcon = false, }) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(DropDownAndToggleButton_1.DropDownAndToggleButton, { iconType: "volume", isMuted: isAudioOutputMuted, onMainButtonClick: () => {
                void handleSpeakerToggle(currentConnectedAudioOutputs, isAudioOutputMuted);
            }, onArrowClick: e => {
                showAudioOutputMenu(currentConnectedAudioOutputs, e);
            }, hidePopoverArrow: hideArrowIcon }),
        react_1.default.createElement(AudioOutputMenu, { triggerId: audioOutputTriggerId, audioOutputsList: currentConnectedAudioOutputs })));
};
exports.AudioOutputButton = AudioOutputButton;
const VideoInputMenu = ({ triggerId, camerasList, }) => {
    return (react_1.default.createElement(react_contexify_1.Menu, { id: triggerId, animation: react_contexify_1.animation.fade }, camerasList.map(m => {
        return (react_1.default.createElement(react_contexify_1.Item, { key: m.deviceId, onClick: () => {
                void utils_1.CallManager.selectCameraByDeviceId(m.deviceId);
            } }, m.label.substr(0, 40)));
    })));
};
const AudioInputMenu = ({ triggerId, audioInputsList, }) => {
    return (react_1.default.createElement(react_contexify_1.Menu, { id: triggerId, animation: react_contexify_1.animation.fade }, audioInputsList.map(m => {
        return (react_1.default.createElement(react_contexify_1.Item, { key: m.deviceId, onClick: () => {
                void utils_1.CallManager.selectAudioInputByDeviceId(m.deviceId);
            } }, m.label.substr(0, 40)));
    })));
};
const AudioOutputMenu = ({ triggerId, audioOutputsList, }) => {
    return (react_1.default.createElement(react_contexify_1.Menu, { id: triggerId, animation: react_contexify_1.animation.fade }, audioOutputsList.map(m => {
        return (react_1.default.createElement(react_contexify_1.Item, { key: m.deviceId, onClick: () => {
                void utils_1.CallManager.selectAudioOutputByDeviceId(m.deviceId);
            } }, m.label.substr(0, 40)));
    })));
};
const ShowInFullScreenButton = ({ isFullScreen }) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const showInFullScreen = () => {
        if (isFullScreen) {
            dispatch((0, call_1.setFullScreenCall)(false));
        }
        else {
            dispatch((0, call_1.setFullScreenCall)(true));
        }
    };
    return (react_1.default.createElement(icon_1.BchatIconButton, { iconSize: 60, iconPadding: "20px", iconType: "fullscreen", backgroundColor: "white", borderRadius: "50%", onClick: showInFullScreen, iconColor: "#2879F9", margin: "10px" }));
};
const HangUpButton = () => {
    const ongoingCallPubkey = (0, react_redux_1.useSelector)(call_2.getHasOngoingCallWithPubkey);
    const handleEndCall = async () => {
        if (ongoingCallPubkey) {
            await utils_1.CallManager.USER_hangup(ongoingCallPubkey);
        }
    };
    return (react_1.default.createElement(icon_1.BchatIconButton, { iconSize: 60, iconPadding: "20px", iconType: "hangup", backgroundColor: "#FC3B3B", borderRadius: "50%", onClick: handleEndCall, iconColor: "#FFFFFF", margin: "10px" }));
};
exports.HangUpButton = HangUpButton;
const showAudioInputMenu = (currentConnectedAudioInputs, e) => {
    if (currentConnectedAudioInputs.length === 0) {
        utils_1.ToastUtils.pushNoAudioInputFound();
        return;
    }
    react_contexify_1.contextMenu.show({
        id: audioTriggerId,
        event: e,
    });
};
const showAudioOutputMenu = (currentConnectedAudioOutputs, e) => {
    if (currentConnectedAudioOutputs.length === 0) {
        utils_1.ToastUtils.pushNoAudioOutputFound();
        return;
    }
    react_contexify_1.contextMenu.show({
        id: audioOutputTriggerId,
        event: e,
    });
};
const showVideoInputMenu = (currentConnectedCameras, e) => {
    if (currentConnectedCameras.length === 0) {
        utils_1.ToastUtils.pushNoCameraFound();
        return;
    }
    react_contexify_1.contextMenu.show({
        id: videoTriggerId,
        event: e,
    });
};
const handleCameraToggle = async (currentConnectedCameras, localStreamVideoIsMuted) => {
    if (!currentConnectedCameras.length) {
        utils_1.ToastUtils.pushNoCameraFound();
        return;
    }
    if (localStreamVideoIsMuted) {
        await utils_1.CallManager.selectCameraByDeviceId(currentConnectedCameras[0].deviceId);
    }
    else {
        await utils_1.CallManager.selectCameraByDeviceId(utils_1.CallManager.DEVICE_DISABLED_DEVICE_ID);
    }
};
const handleMicrophoneToggle = async (currentConnectedAudioInputs, isAudioMuted) => {
    if (!currentConnectedAudioInputs.length) {
        utils_1.ToastUtils.pushNoAudioInputFound();
        return;
    }
    if (isAudioMuted) {
        await utils_1.CallManager.selectAudioInputByDeviceId(currentConnectedAudioInputs[0].deviceId);
    }
    else {
        await utils_1.CallManager.selectAudioInputByDeviceId(utils_1.CallManager.DEVICE_DISABLED_DEVICE_ID);
    }
};
const handleSpeakerToggle = async (currentConnectedAudioOutputs, isAudioOutputMuted) => {
    if (!currentConnectedAudioOutputs.length) {
        utils_1.ToastUtils.pushNoAudioInputFound();
        return;
    }
    if (isAudioOutputMuted) {
        await utils_1.CallManager.selectAudioOutputByDeviceId(currentConnectedAudioOutputs[0].deviceId);
    }
    else {
        await utils_1.CallManager.selectAudioOutputByDeviceId(utils_1.CallManager.DEVICE_DISABLED_DEVICE_ID);
    }
};
const StyledCallWindowControls = styled_components_1.default.div `
  position: absolute;

  bottom: 0px;
  width: ${props => (props.isFullScreen ? "100vw" : '100%')};
  height: 100%;
  align-items: flex-end;
  padding: 10px;
  border-radius: 10px;
  margin-left: auto;
  margin-right: auto;
  left: 0;
  right: 0;
  transition: all 0.25s ease-in-out;

  display: flex;

  justify-content: center;
  opacity: ${props => (props.makeVisible ? 1 : 0)};
`;
const CallWindowControls = ({ currentConnectedCameras, currentConnectedAudioInputs, currentConnectedAudioOutputs, isAudioMuted, isAudioOutputMuted, remoteStreamVideoIsMuted, localStreamVideoIsMuted, isFullScreen, }) => {
    const [makeVisible, setMakeVisible] = (0, react_1.useState)(true);
    const setMakeVisibleTrue = () => {
        setMakeVisible(true);
    };
    const setMakeVisibleFalse = () => {
        setMakeVisible(false);
    };
    (0, react_1.useEffect)(() => {
        setMakeVisibleTrue();
        document.addEventListener('mouseenter', setMakeVisibleTrue);
        document.addEventListener('mouseleave', setMakeVisibleFalse);
        return () => {
            document.removeEventListener('mouseenter', setMakeVisibleTrue);
            document.removeEventListener('mouseleave', setMakeVisibleFalse);
        };
    }, [isFullScreen]);
    return (react_1.default.createElement(StyledCallWindowControls, { makeVisible: makeVisible, isFullScreen: isFullScreen },
        !remoteStreamVideoIsMuted && react_1.default.createElement(ShowInFullScreenButton, { isFullScreen: isFullScreen }),
        react_1.default.createElement(exports.VideoInputButton, { currentConnectedCameras: currentConnectedCameras, localStreamVideoIsMuted: localStreamVideoIsMuted, hideArrowIcon: isFullScreen }),
        react_1.default.createElement(exports.AudioInputButton, { currentConnectedAudioInputs: currentConnectedAudioInputs, isAudioMuted: isAudioMuted, hideArrowIcon: isFullScreen }),
        react_1.default.createElement(exports.AudioOutputButton, { currentConnectedAudioOutputs: currentConnectedAudioOutputs, isAudioOutputMuted: isAudioOutputMuted, hideArrowIcon: isFullScreen }),
        react_1.default.createElement(exports.HangUpButton, null)));
};
exports.CallWindowControls = CallWindowControls;
