"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallInFullScreenContainer = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const useKey_1 = __importDefault(require("react-use/lib/useKey"));
const styled_components_1 = __importDefault(require("styled-components"));
const useVideoEventListener_1 = require("../../hooks/useVideoEventListener");
const call_1 = require("../../state/ducks/call");
const call_2 = require("../../state/selectors/call");
const CallButtons_1 = require("./CallButtons");
const DraggableCallContainer_1 = require("./DraggableCallContainer");
const CallInFullScreenVisible = styled_components_1.default.div `
  position: absolute;
  z-index: 9;
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  display: flex;
  flex-direction: column;
  background-color: var(--color-inbox-background);
  // border: var(--bchat-border);
  opacity: 1;
  width:100vw;
`;
const StyledLocalVideoElement = styled_components_1.default.video `
  height: 30%;
  width: 16%;
  bottom: 0;
  right: 0;
  position: absolute;
  opacity: ${props => (props.isVideoMuted ? 0 : 1)};
`;
const CallInFullScreenContainer = () => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const ongoingCallWithFocused = (0, react_redux_1.useSelector)(call_2.getHasOngoingCallWithFocusedConvo);
    const hasOngoingCallFullScreen = (0, react_redux_1.useSelector)(call_2.getCallIsInFullScreen);
    const { remoteStream, remoteStreamVideoIsMuted, localStream, currentConnectedAudioInputs, currentConnectedAudioOutputs, currentConnectedCameras, isAudioMuted, isAudioOutputMuted, localStreamVideoIsMuted, } = (0, useVideoEventListener_1.useVideoCallEventsListener)('CallInFullScreenContainer', true);
    const videoRefRemote = react_1.default.useRef(null);
    const videoRefLocal = react_1.default.useRef(null);
    function toggleFullScreenOFF() {
        dispatch((0, call_1.setFullScreenCall)(false));
    }
    (0, useKey_1.default)('Escape', () => {
        toggleFullScreenOFF();
    });
    (0, react_1.useEffect)(() => {
        if (remoteStreamVideoIsMuted) {
            dispatch((0, call_1.setFullScreenCall)(false));
        }
    }, [remoteStreamVideoIsMuted]);
    if (!ongoingCallWithFocused || !hasOngoingCallFullScreen) {
        return null;
    }
    if (videoRefRemote?.current) {
        if (videoRefRemote.current.srcObject !== remoteStream) {
            videoRefRemote.current.srcObject = remoteStream;
        }
    }
    if (videoRefLocal?.current) {
        if (videoRefLocal.current.srcObject !== localStream) {
            videoRefLocal.current.srcObject = localStream;
        }
    }
    return (react_1.default.createElement(CallInFullScreenVisible, { onClick: toggleFullScreenOFF },
        react_1.default.createElement(DraggableCallContainer_1.StyledVideoElement, { ref: videoRefRemote, autoPlay: true, isVideoMuted: remoteStreamVideoIsMuted }),
        react_1.default.createElement(StyledLocalVideoElement, { ref: videoRefLocal, autoPlay: true, isVideoMuted: localStreamVideoIsMuted }),
        react_1.default.createElement(CallButtons_1.CallWindowControls, { currentConnectedAudioInputs: currentConnectedAudioInputs, currentConnectedAudioOutputs: currentConnectedAudioOutputs, currentConnectedCameras: currentConnectedCameras, isAudioMuted: isAudioMuted, isAudioOutputMuted: isAudioOutputMuted, localStreamVideoIsMuted: localStreamVideoIsMuted, remoteStreamVideoIsMuted: remoteStreamVideoIsMuted, isFullScreen: hasOngoingCallFullScreen })));
};
exports.CallInFullScreenContainer = CallInFullScreenContainer;
