"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatEmojiPanel = void 0;
const react_1 = __importDefault(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const emoji_mart_1 = require("emoji-mart");
const bchat_1 = require("../../bchat");
const react_redux_1 = require("react-redux");
const theme_1 = require("../../state/selectors/theme");
const BchatEmojiPanel = (props) => {
    const { onEmojiClicked, show } = props;
    const darkMode = (0, react_redux_1.useSelector)(theme_1.getTheme) === 'dark';
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)('bchat-emoji-panel', show && 'show') },
        react_1.default.createElement(emoji_mart_1.Picker, { backgroundImageFn: () => './images/emoji/emoji-sheet-twitter-32.png', set: 'twitter', sheetSize: 32, darkMode: darkMode, color: bchat_1.Constants.UI.COLORS.GREEN, showPreview: true, title: '', onSelect: onEmojiClicked, autoFocus: true })));
};
exports.BchatEmojiPanel = BchatEmojiPanel;
