"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatQuotedMessageComposition = void 0;
const react_1 = __importStar(require("react"));
const icon_1 = require("../icon");
const styled_components_1 = __importDefault(require("styled-components"));
const react_redux_1 = require("react-redux");
const conversations_1 = require("../../state/ducks/conversations");
const conversations_2 = require("../../state/selectors/conversations");
const Attachment_1 = require("../../types/Attachment");
const MIME_1 = require("../../types/MIME");
const Flex_1 = require("../basic/Flex");
const Image_1 = require("./Image");
const QuotedMessageComposition = styled_components_1.default.div `
  width: 100%;
  padding-inline-end: var(--margins-md);
  padding-inline-start: var(--margins-md);
`;
const QuotedMessageCompositionReply = styled_components_1.default.div `
  background: var(--color-quote-bottom-bar-background);
  border-radius: var(--margins-sm);
  padding: var(--margins-xs);
  box-shadow: var(--color-bchat-shadow);
  margin: var(--margins-xs);
`;
const Subtle = styled_components_1.default.div `
  overflow: hidden;
  text-overflow: ellipsis;
  word-break: break-all;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  display: -webkit-box;
  color: var(--color-text);
`;
const ReplyingTo = styled_components_1.default.div `
  color: var(--color-text);
`;
const BchatQuotedMessageComposition = () => {
    const quotedMessageProps = (0, react_redux_1.useSelector)(conversations_2.getQuotedMessage);
    const dispatch = (0, react_redux_1.useDispatch)();
    const { text: body, attachments } = quotedMessageProps || {};
    const hasAttachments = attachments && attachments.length > 0;
    let hasImageAttachment = false;
    let firstImageAttachment;
    if (attachments?.length && attachments[0].contentType !== MIME_1.AUDIO_MP3 && attachments[0].thumbnail) {
        firstImageAttachment = attachments[0];
        hasImageAttachment = true;
    }
    const hasAudioAttachment = hasAttachments && attachments && attachments.length > 0 && (0, Attachment_1.isAudio)(attachments);
    const removeQuotedMessage = (0, react_1.useCallback)(() => {
        dispatch((0, conversations_1.quoteMessage)(undefined));
    }, []);
    if (!quotedMessageProps?.id) {
        return null;
    }
    return (react_1.default.createElement(QuotedMessageComposition, null,
        react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "space-between", flexGrow: 1, margin: 'var(--margins-xs)' },
            react_1.default.createElement(ReplyingTo, null, window.i18n('replyingToMessage')),
            react_1.default.createElement(icon_1.BchatIconButton, { iconType: "exit", iconSize: "small", onClick: removeQuotedMessage })),
        react_1.default.createElement(QuotedMessageCompositionReply, null,
            react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "space-between", margin: 'var(--margins-xs)' },
                react_1.default.createElement(Subtle, null, (hasAttachments && window.i18n('mediaMessage')) || body),
                hasImageAttachment && (react_1.default.createElement(Image_1.Image, { alt: (0, Attachment_1.getAlt)(firstImageAttachment), attachment: firstImageAttachment, height: 100, width: 100, url: firstImageAttachment.thumbnail.objectUrl })),
                hasAudioAttachment && react_1.default.createElement(icon_1.BchatIcon, { iconType: "microphone", iconSize: "huge" })))));
};
exports.BchatQuotedMessageComposition = BchatQuotedMessageComposition;
