"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageContentWithStatuses = void 0;
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const conversationInteractions_1 = require("../../../../interactions/conversationInteractions");
const conversations_1 = require("../../../../state/ducks/conversations");
const conversations_2 = require("../../../../state/selectors/conversations");
const MessageAuthorText_1 = require("./MessageAuthorText");
const MessageContent_1 = require("./MessageContent");
const MessageContextMenu_1 = require("./MessageContextMenu");
const MessageStatus_1 = require("./MessageStatus");
const MessageContentWithStatuses = (props) => {
    const contentProps = (0, react_redux_1.useSelector)(state => (0, conversations_2.getMessageContentWithStatusesSelectorProps)(state, props.messageId));
    const dispatch = (0, react_redux_1.useDispatch)();
    const multiSelectMode = (0, react_redux_1.useSelector)(conversations_2.isMessageSelectionMode);
    const onClickOnMessageOuterContainer = (0, react_1.useCallback)((event) => {
        if (multiSelectMode && messageId) {
            event.preventDefault();
            event.stopPropagation();
            dispatch((0, conversations_1.toggleSelectedMessageId)(messageId));
        }
    }, [window.contextMenuShown, props?.messageId, multiSelectMode, props?.isDetailView]);
    const onDoubleClickReplyToMessage = (e) => {
        const currentSelection = window.getSelection();
        const currentSelectionString = currentSelection?.toString() || undefined;
        if (!currentSelectionString ||
            currentSelectionString.length === 0 ||
            !currentSelectionString.includes(' ')) {
            void (0, conversationInteractions_1.replyToMessage)(messageId);
            currentSelection?.empty();
            e.preventDefault();
            return;
        }
    };
    const { messageId, ctxMenuID, isDetailView, dataTestId } = props;
    if (!contentProps) {
        return null;
    }
    const { direction, isDeleted, hasAttachments, isTrustedForAttachmentDownload } = contentProps;
    const isIncoming = direction === 'incoming';
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)('module-message', `module-message--${direction}`), role: "button", onClick: onClickOnMessageOuterContainer, onDoubleClickCapture: onDoubleClickReplyToMessage, style: { width: hasAttachments && isTrustedForAttachmentDownload ? 'min-content' : 'auto' }, "data-testid": dataTestId },
        react_1.default.createElement(MessageStatus_1.MessageStatus, { dataTestId: "msg-status-incoming", messageId: messageId, isCorrectSide: isIncoming }),
        react_1.default.createElement("div", null,
            react_1.default.createElement(MessageAuthorText_1.MessageAuthorText, { messageId: messageId }),
            react_1.default.createElement(MessageContent_1.MessageContent, { messageId: messageId, isDetailView: isDetailView })),
        react_1.default.createElement(MessageStatus_1.MessageStatus, { dataTestId: "msg-status-outgoing", messageId: messageId, isCorrectSide: !isIncoming }),
        !isDeleted && react_1.default.createElement(MessageContextMenu_1.MessageContextMenu, { messageId: messageId, contextMenuId: ctxMenuID })));
};
exports.MessageContentWithStatuses = MessageContentWithStatuses;
