"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageStatus = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const conversations_1 = require("../../../../state/selectors/conversations");
const OutgoingMessageStatus_1 = require("./OutgoingMessageStatus");
const MessageStatus = (props) => {
    const { isCorrectSide, dataTestId } = props;
    const selected = (0, react_redux_1.useSelector)(state => (0, conversations_1.getMessageStatusProps)(state, props.messageId));
    if (!selected) {
        return null;
    }
    const { status, direction } = selected;
    if (!isCorrectSide) {
        return null;
    }
    const isIncoming = direction === 'incoming';
    const showStatus = !isIncoming && Boolean(status);
    if (!showStatus) {
        return null;
    }
    return react_1.default.createElement(OutgoingMessageStatus_1.OutgoingMessageStatus, { dataTestId: dataTestId, status: status });
};
exports.MessageStatus = MessageStatus;
