"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentMessage = void 0;
const react_1 = __importDefault(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const ReadableMessage_1 = require("./ReadableMessage");
const icon_1 = require("../../../icon");
const common_1 = require("electron/common");
const PaymentMessage = (props) => {
    const { messageId, receivedAt, isUnread } = props;
    const classes = ['payment'];
    const currentValueFromSettings = window.getSettingValue('font-size-setting') || "Small";
    if (props.direction === 'outgoing') {
        classes.push('invitation-outgoing');
    }
    function openToExplore(traxId) {
        if (window.networkType === 'mainnet') {
            void common_1.shell.openExternal(`http://explorer.beldex.io/tx/${traxId}`);
        }
        else {
            void common_1.shell.openExternal(`http://154.26.139.105/tx/${traxId}`);
        }
    }
    function FontSizeChanger(fontSize) {
        let size;
        if (currentValueFromSettings === "Small") {
            size = fontSize;
        }
        else if (currentValueFromSettings === "Medium") {
            size = fontSize + 2;
        }
        else {
            size = fontSize + 4;
        }
        return size;
    }
    function HindTxt() {
        const iconColor = 'var(--color-text)';
        if (props.messageId === '1234-567-7890') {
            return react_1.default.createElement("div", null,
                react_1.default.createElement("span", { style: { marginRight: '5px' } }, "Initiating transaction"),
                react_1.default.createElement(icon_1.BchatIcon, { rotateDuration: 2, iconColor: iconColor, iconType: "loading", iconSize: "tiny" }));
        }
        else if (props.direction === 'outgoing') {
            return react_1.default.createElement("div", null,
                react_1.default.createElement("span", { style: { marginRight: '5px' } }, "Sent Successfully!"),
                react_1.default.createElement(icon_1.BchatIcon, { iconColor: iconColor, iconType: "doubleCheckCircleFilled", iconSize: "tiny" }));
        }
        else {
            return react_1.default.createElement("div", null, "Received successfully ");
        }
    }
    return (react_1.default.createElement(ReadableMessage_1.ReadableMessage, { messageId: messageId, receivedAt: receivedAt, isUnread: isUnread, key: `readable-message-${messageId}` },
        react_1.default.createElement("div", { className: "group-invitation-container", id: `msg-${props.messageId}` },
            react_1.default.createElement("div", { className: (0, classnames_1.default)(classes), onClick: () => props.txnId ? openToExplore(props.txnId) : "", style: { cursor: props.txnId ? "pointer" : "unset" } },
                react_1.default.createElement("div", { className: props.direction === 'outgoing' ? "contents" : "contents-incoming" },
                    react_1.default.createElement("div", null,
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: 'borderWithBeldex', iconSize: "huge" })),
                    react_1.default.createElement("div", { className: 'amount', style: { fontSize: `${FontSizeChanger(18)}px` } },
                        props.amount,
                        " BDX")),
                react_1.default.createElement("div", { className: props.direction === 'outgoing' ? 'hint-out' : 'hintTxt', style: { fontSize: `${FontSizeChanger(12)}px` } },
                    react_1.default.createElement(HindTxt, null))))));
};
exports.PaymentMessage = PaymentMessage;
