"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationBubble = void 0;
const react_1 = __importDefault(require("react"));
const styled_components_1 = __importDefault(require("styled-components"));
const icon_1 = require("../../../../icon");
const NotificationBubbleFlex = styled_components_1.default.div `
  display: flex;
  background-color: var(--message-bubbles-received-background-color);
  color: var(--color-text);
  // width: 90%;
  // max-width: 584px;
  margin: 10px auto;
  padding: 5px 10px;
  border-radius: 12px;
  word-break: break-word;
  text-align: center;
  align-items: center;
  justify-content: center;
`;
const NotificationBubbleText = styled_components_1.default.div `
  color: var(--color-text);
  // margin-left: 45px;
`;
const NotificationBubbleIconContainer = styled_components_1.default.div `
  margin: auto 10px;
  width: 30px;
  height: 30px;
  display: flex;
  justify-content: center;
  align-items: center;
`;
const FlexCenter = styled_components_1.default.div `
    display: flex;
    justify-content: center;
    width: 100%;
`;
const NotificationBubble = (props) => {
    const { notificationText, iconType, iconColor, bgColor } = props;
    return (react_1.default.createElement(FlexCenter, null,
        react_1.default.createElement(NotificationBubbleFlex, null,
            iconType && (react_1.default.createElement(NotificationBubbleIconContainer, { style: { backgroundColor: bgColor } },
                react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: iconType, iconColor: iconColor, iconPadding: "auto 10px" }))),
            react_1.default.createElement(NotificationBubbleText, null, notificationText))));
};
exports.NotificationBubble = NotificationBubble;
