"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatSeedModal = void 0;
const react_1 = __importStar(require("react"));
const utils_1 = require("../../bchat/utils");
const Text_1 = require("../basic/Text");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const react_redux_1 = require("react-redux");
const storage_1 = require("../../util/storage");
const ActionsPanel_1 = require("../leftpane/ActionsPanel");
const Seed = (props) => {
    const { recoveryPhrase, onClickCopy } = props;
    const i18n = window.i18n;
    const dispatch = (0, react_redux_1.useDispatch)();
    const copyRecoveryPhrase = (recoveryPhraseToCopy) => {
        window.clipboard.writeText(recoveryPhraseToCopy);
        utils_1.ToastUtils.pushCopiedToClipBoard();
        if (onClickCopy) {
            onClickCopy();
        }
        dispatch((0, modalDialog_1.recoveryPhraseModal)(null));
    };
    return (react_1.default.createElement("div", { className: "bchat-modal__box" },
        react_1.default.createElement("div", { className: "bchat-modal__centered text-center " },
            react_1.default.createElement("p", { className: "bchat-modal__description", style: { fontSize: '22px' } }, i18n('recoveryPhrase')),
            react_1.default.createElement(Text_1.SpacerXS, null),
            react_1.default.createElement("i", { "data-testid": "recovery-phrase-seed-modal", className: "bchat-modal__text-highlight" }, recoveryPhrase)),
        react_1.default.createElement(Text_1.SpacerLG, null),
        react_1.default.createElement("div", { className: "bchat-modal__button-group" },
            react_1.default.createElement("div", { className: 'copyIconBtn', onClick: () => { copyRecoveryPhrase(recoveryPhrase); }, "data-tip": "Copy", "data-place": "right" },
                react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", viewBox: "0 0 18.151 18.151" },
                    react_1.default.createElement("path", { id: "copy_icon", d: "M3.815,2A1.815,1.815,0,0,0,2,3.815V16.521H3.815V3.815H16.521V2Zm3.63,3.63A1.815,1.815,0,0,0,5.63,7.445V18.336a1.815,1.815,0,0,0,1.815,1.815H18.336a1.815,1.815,0,0,0,1.815-1.815V7.445A1.815,1.815,0,0,0,18.336,5.63Zm0,1.815H18.336V18.336H7.445Z", transform: "translate(-2 -2)" })),
                react_1.default.createElement("div", { role: "button", style: { marginLeft: "5px" } }, window.i18n('editMenuCopy')))),
        react_1.default.createElement(Text_1.SpacerLG, null),
        react_1.default.createElement(ActionsPanel_1.BchatToolTip, { effect: "solid" })));
};
const BchatSeedModalInner = (props) => {
    const { onClickOk } = props;
    const [loadingPassword, setLoadingPassword] = (0, react_1.useState)(true);
    const [loadingSeed, setLoadingSeed] = (0, react_1.useState)(true);
    const [recoveryPhrase, setRecoveryPhrase] = (0, react_1.useState)('');
    (0, react_1.useEffect)(() => {
        setTimeout(() => document.getElementById('seed-input-password')?.focus(), 100);
        void checkHasPassword();
        void getRecoveryPhrase();
    }, []);
    const checkHasPassword = async () => {
        if (!loadingPassword) {
            return;
        }
        setLoadingPassword(false);
    };
    const getRecoveryPhrase = async () => {
        if (recoveryPhrase) {
            return false;
        }
        const newRecoveryPhrase = (0, storage_1.getCurrentRecoveryPhrase)();
        setRecoveryPhrase(newRecoveryPhrase);
        setLoadingSeed(false);
        return true;
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, !loadingSeed && (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Text_1.SpacerSM, null),
        react_1.default.createElement(Seed, { recoveryPhrase: recoveryPhrase, onClickCopy: onClickOk })))));
};
exports.BchatSeedModal = BchatSeedModalInner;
