"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalContainer = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const modal_1 = require("../../state/selectors/modal");
const AdminLeaveClosedGroupDialog_1 = require("./AdminLeaveClosedGroupDialog");
const InviteContactsDialog_1 = require("./InviteContactsDialog");
const DeleteAccountModal_1 = require("./DeleteAccountModal");
const EditProfileDialog_1 = require("./EditProfileDialog");
const OnionStatusPathDialog_1 = require("./OnionStatusPathDialog");
const UserDetailsDialog_1 = require("./UserDetailsDialog");
const BchatConfirm_1 = require("./BchatConfirm");
const BchatPasswordDialog_1 = require("./BchatPasswordDialog");
const BchatSeedModal_1 = require("./BchatSeedModal");
const ModeratorsAddDialog_1 = require("./ModeratorsAddDialog");
const ModeratorsRemoveDialog_1 = require("./ModeratorsRemoveDialog");
const UpdateGroupMembersDialog_1 = require("./UpdateGroupMembersDialog");
const UpdateGroupNameDialog_1 = require("./UpdateGroupNameDialog");
const BchatNicknameDialog_1 = require("./BchatNicknameDialog");
const BanOrUnbanUserDialog_1 = require("./BanOrUnbanUserDialog");
const BchatWalletChangePassword_1 = require("../wallet/BchatWalletChangePassword");
const BchatWalletModal_1 = require("../wallet/BchatWalletModal");
const BchatWalletTransactionInitModal_1 = require("../wallet/BchatWalletTransactionInitModal");
const BchatWalletSendConfirmModal_1 = require("./BchatWalletSendConfirmModal");
const updateInstructionModal_1 = __importDefault(require("./updateInstructionModal"));
const BchatWalletPasswordModal_1 = require("./BchatWalletPasswordModal");
const bchatAlertConfirmModal_1 = require("./bchatAlertConfirmModal");
const ModalContainer = () => {
    const confirmModalState = (0, react_redux_1.useSelector)(modal_1.getConfirmModal);
    const inviteModalState = (0, react_redux_1.useSelector)(modal_1.getInviteContactModal);
    const addModeratorsModalState = (0, react_redux_1.useSelector)(modal_1.getAddModeratorsModal);
    const removeModeratorsModalState = (0, react_redux_1.useSelector)(modal_1.getRemoveModeratorsModal);
    const updateGroupMembersModalState = (0, react_redux_1.useSelector)(modal_1.getUpdateGroupMembersModal);
    const updateGroupNameModalState = (0, react_redux_1.useSelector)(modal_1.getUpdateGroupNameModal);
    const userDetailsModalState = (0, react_redux_1.useSelector)(modal_1.getUserDetailsModal);
    const changeNicknameModal = (0, react_redux_1.useSelector)(modal_1.getChangeNickNameDialog);
    const editProfileModalState = (0, react_redux_1.useSelector)(modal_1.getEditProfileDialog);
    const onionPathModalState = (0, react_redux_1.useSelector)(modal_1.getOnionPathDialog);
    const recoveryPhraseModalState = (0, react_redux_1.useSelector)(modal_1.getRecoveryPhraseDialog);
    const adminLeaveClosedGroupModalState = (0, react_redux_1.useSelector)(modal_1.getAdminLeaveClosedGroupDialog);
    const bchatPasswordModalState = (0, react_redux_1.useSelector)(modal_1.getBchatPasswordDialog);
    const deleteAccountModalState = (0, react_redux_1.useSelector)(modal_1.getDeleteAccountModalState);
    const banOrUnbanUserModalState = (0, react_redux_1.useSelector)(modal_1.getBanOrUnbanUserModalState);
    const ChangePasswordModalState = (0, react_redux_1.useSelector)(modal_1.getChangePasswordModalState);
    const walletSettingMiniModal = (0, react_redux_1.useSelector)(modal_1.getwalletSettingMiniModalState);
    const TransactionInitModalState = (0, react_redux_1.useSelector)(modal_1.getTransactionInitModal);
    const BchatSendConfirmState = (0, react_redux_1.useSelector)(modal_1.getwalletSendConfirmModal);
    const BchatUpdateInstruntionState = (0, react_redux_1.useSelector)(modal_1.getBchatUpdateInstruntion);
    const BchatWalletPasswordModalState = (0, react_redux_1.useSelector)(modal_1.getBchatWalletPasswordModal);
    const BchatAlertConfirmModalState = (0, react_redux_1.useSelector)(modal_1.getBchatAlertConfirmModal);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        banOrUnbanUserModalState && react_1.default.createElement(BanOrUnbanUserDialog_1.BanOrUnBanUserDialog, { ...banOrUnbanUserModalState }),
        inviteModalState && react_1.default.createElement(InviteContactsDialog_1.InviteContactsDialog, { ...inviteModalState }),
        addModeratorsModalState && react_1.default.createElement(ModeratorsAddDialog_1.AddModeratorsDialog, { ...addModeratorsModalState }),
        removeModeratorsModalState && react_1.default.createElement(ModeratorsRemoveDialog_1.RemoveModeratorsDialog, { ...removeModeratorsModalState }),
        updateGroupMembersModalState && (react_1.default.createElement(UpdateGroupMembersDialog_1.UpdateGroupMembersDialog, { ...updateGroupMembersModalState })),
        updateGroupNameModalState && react_1.default.createElement(UpdateGroupNameDialog_1.UpdateGroupNameDialog, { ...updateGroupNameModalState }),
        userDetailsModalState && react_1.default.createElement(UserDetailsDialog_1.UserDetailsDialog, { ...userDetailsModalState }),
        changeNicknameModal && react_1.default.createElement(BchatNicknameDialog_1.BchatNicknameDialog, { ...changeNicknameModal }),
        editProfileModalState && react_1.default.createElement(EditProfileDialog_1.EditProfileDialog, { ...editProfileModalState }),
        onionPathModalState && react_1.default.createElement(OnionStatusPathDialog_1.OnionPathModal, { ...onionPathModalState }),
        recoveryPhraseModalState && react_1.default.createElement(BchatSeedModal_1.BchatSeedModal, { ...recoveryPhraseModalState }),
        adminLeaveClosedGroupModalState && (react_1.default.createElement(AdminLeaveClosedGroupDialog_1.AdminLeaveClosedGroupDialog, { ...adminLeaveClosedGroupModalState })),
        bchatPasswordModalState && react_1.default.createElement(BchatPasswordDialog_1.BchatPasswordDialog, { ...bchatPasswordModalState }),
        deleteAccountModalState && react_1.default.createElement(DeleteAccountModal_1.DeleteAccountModal, { ...deleteAccountModalState }),
        confirmModalState && react_1.default.createElement(BchatConfirm_1.BchatConfirm, { ...confirmModalState }),
        ChangePasswordModalState && react_1.default.createElement(BchatWalletChangePassword_1.ChangePassword, null),
        walletSettingMiniModal && react_1.default.createElement(BchatWalletModal_1.WalletModal, { ...walletSettingMiniModal }),
        TransactionInitModalState && react_1.default.createElement(BchatWalletTransactionInitModal_1.TransactionInitModal, null),
        BchatSendConfirmState && react_1.default.createElement(BchatWalletSendConfirmModal_1.BchatSendConfirm, { ...BchatSendConfirmState }),
        BchatUpdateInstruntionState && react_1.default.createElement(updateInstructionModal_1.default, { ...BchatUpdateInstruntionState }),
        BchatWalletPasswordModalState && react_1.default.createElement(BchatWalletPasswordModal_1.BchatWalletPasswordModal, { ...BchatWalletPasswordModalState }),
        BchatAlertConfirmModalState && react_1.default.createElement(bchatAlertConfirmModal_1.BchatAlertConfirmModal, { ...BchatAlertConfirmModalState })));
};
exports.ModalContainer = ModalContainer;
