"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserDetailsDialog = void 0;
const react_1 = __importStar(require("react"));
const useKey_1 = __importDefault(require("react-use/lib/useKey"));
const conversation_1 = require("../../models/conversation");
const conversations_1 = require("../../bchat/conversations");
const utils_1 = require("../../bchat/utils");
const conversations_2 = require("../../state/ducks/conversations");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const Avatar_1 = require("../avatar/Avatar");
const Text_1 = require("../basic/Text");
const BchatWrapperModal_1 = require("../BchatWrapperModal");
const UserDetailsDialog = (props) => {
    const [isEnlargedImageShown, setIsEnlargedImageShown] = (0, react_1.useState)(false);
    const convo = (0, conversations_1.getConversationController)().get(props.conversationId);
    const size = isEnlargedImageShown ? Avatar_1.AvatarSize.HUGE : Avatar_1.AvatarSize.XL;
    function closeDialog() {
        window.inboxStore?.dispatch((0, modalDialog_1.updateUserDetailsModal)(null));
    }
    async function onClickStartConversation() {
        const conversation = await (0, conversations_1.getConversationController)().getOrCreateAndWait(convo.id, conversation_1.ConversationTypeEnum.PRIVATE);
        await (0, conversations_2.openConversationWithMessages)({ conversationKey: conversation.id, messageId: null });
        closeDialog();
    }
    (0, useKey_1.default)('Enter', () => {
        void onClickStartConversation();
    }, undefined, [props.conversationId]);
    function copyBchatID(bchatID) {
        window.clipboard.writeText(bchatID);
        utils_1.ToastUtils.pushCopiedToClipBoard();
    }
    return (react_1.default.createElement(BchatWrapperModal_1.BchatWrapperModal, { title: props.userName, onClose: closeDialog, showExitIcon: true },
        react_1.default.createElement("div", { style: { width: '410px', paddingTop: '20px' } },
            react_1.default.createElement("div", { className: "avatar-center" },
                react_1.default.createElement("div", { className: "avatar-center-inner" },
                    react_1.default.createElement(Avatar_1.Avatar, { size: size, onAvatarClick: () => {
                            setIsEnlargedImageShown(!isEnlargedImageShown);
                        }, pubkey: props.conversationId }))),
            react_1.default.createElement("div", { className: 'bchat-modal__centered-display' },
                react_1.default.createElement("div", { className: 'profile-value' }, convo.id),
                react_1.default.createElement("div", { onClick: () => copyBchatID(convo.id), className: "bchat-modal__centered-display-icon" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "18.151", height: "18.151", viewBox: "0 0 18.151 18.151" },
                        react_1.default.createElement("path", { id: "copy_icon", d: "M3.815,2A1.815,1.815,0,0,0,2,3.815V16.521H3.815V3.815H16.521V2Zm3.63,3.63A1.815,1.815,0,0,0,5.63,7.445V18.336a1.815,1.815,0,0,0,1.815,1.815H18.336a1.815,1.815,0,0,0,1.815-1.815V7.445A1.815,1.815,0,0,0,18.336,5.63Zm0,1.815H18.336V18.336H7.445Z", transform: "translate(-2 -2)" })))),
            react_1.default.createElement(Text_1.SpacerLG, null),
            react_1.default.createElement("div", { className: "bchat-modal__button-group__center" }))));
};
exports.UserDetailsDialog = UserDetailsDialog;
