"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatAlertConfirmModal = void 0;
const react_1 = __importStar(require("react"));
const modalDialog_1 = require("../../state/ducks/modalDialog");
const Text_1 = require("../basic/Text");
const BchatButton_1 = require("../basic/BchatButton");
const BchatSpinner_1 = require("../basic/BchatSpinner");
const BchatWrapperModal_1 = require("../BchatWrapperModal");
const BchatAlertConfirmModal = (props) => {
    const { settings = false, onClickOk, onClickClose, onClickCancel, btndisable } = props;
    const [isLoading, setIsLoading] = (0, react_1.useState)(false);
    const okText = window.i18n('ok');
    const cancelText = window.i18n('cancel');
    const onClickOkHandler = async () => {
        if (onClickOk) {
            setIsLoading(true);
            try {
                await onClickOk();
            }
            catch (e) {
                window.log.warn(e);
            }
            finally {
                setIsLoading(false);
            }
        }
    };
    const onClickCancelHandler = () => {
        if (onClickCancel) {
            onClickCancel();
        }
        if (onClickClose) {
            onClickClose();
        }
        window.inboxStore?.dispatch((0, modalDialog_1.updateConfirmModal)(null));
    };
    return (react_1.default.createElement(BchatWrapperModal_1.BchatWrapperModal, { title: '', onClose: onClickClose, showExitIcon: false, showHeader: false },
        react_1.default.createElement("div", { className: "bchat-modal__centered" },
            react_1.default.createElement("div", { className: "bchat-modal-imgConfirmBox" },
                react_1.default.createElement("img", { src: 'images/bchat/walletinchat.svg', width: '50px', height: '50px' }),
                react_1.default.createElement(Text_1.SpacerMD, null),
                react_1.default.createElement("div", { className: "bchat-modal-imgConfirmBox-header" }, window.i18n('payYouChat')),
                react_1.default.createElement(Text_1.SpacerMD, null),
                react_1.default.createElement("div", { className: "bchat-modal-imgConfirmBox-message" }, settings ? (window.i18n('warningWalletPassword')) : (react_1.default.createElement(react_1.default.Fragment, null,
                    "Enable pay as you chat from ",
                    react_1.default.createElement("span", null, "Settings -> Chat -> Pay As You Chat "),
                    "to use this option"))),
                react_1.default.createElement(BchatSpinner_1.BchatSpinner, { loading: isLoading }))),
        react_1.default.createElement("div", { className: "bchat-modal__button-group" },
            react_1.default.createElement(BchatButton_1.BchatButton, { text: cancelText, buttonColor: BchatButton_1.BchatButtonColor.White, onClick: onClickCancelHandler, dataTestId: "Bchat-confirm-cancel-button", style: { width: '120px', height: '35px' } }),
            react_1.default.createElement(BchatButton_1.BchatButton, { text: okText, buttonColor: BchatButton_1.BchatButtonColor.Green, onClick: onClickOkHandler, dataTestId: "Bchat-confirm-ok-button", disabled: btndisable ? btndisable : false, style: { width: '120px', height: '35px' } }))));
};
exports.BchatAlertConfirmModal = BchatAlertConfirmModal;
