"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LeftPaneSettingSection = void 0;
const react_1 = __importDefault(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const LeftPaneSectionHeader_1 = require("./LeftPaneSectionHeader");
const react_redux_1 = require("react-redux");
const section_1 = require("../../state/ducks/section");
const section_2 = require("../../state/selectors/section");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const BchatButton_1 = require("../basic/BchatButton");
const icon_1 = require("../icon");
const BchatSettings_1 = require("../settings/BchatSettings");
const userConfig_1 = require("../../state/ducks/userConfig");
const LeftPaneSettingsCategoryRow = () => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const focusedSettingsSection = (0, react_redux_1.useSelector)(section_2.getFocusedSettingsSection);
    const dataTestId = `settings-menu-item`;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Chat === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Chat));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement(icon_1.BchatIcon, { iconSize: 23, iconType: "chat" })),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('Chat'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Chat === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.WalletSettings === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.WalletSettings));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement(icon_1.BchatIcon, { iconSize: 23, iconType: "wallet", iconColor: '#2879FB' })),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('WalletSettingsTitle')),
                react_1.default.createElement("span", { className: "beta" }, "BETA")),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.WalletSettings === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Privacy === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Privacy));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "18.192", height: "21.53", viewBox: "0 0 18.192 21.53" },
                        react_1.default.createElement("path", { id: "privacy", d: "M14.116,2a.717.717,0,0,0-.5.184,13.576,13.576,0,0,1-7.9,3.165A.717.717,0,0,0,5,6.067v5.866c0,3.2,1.478,8.453,8.817,11.542a.717.717,0,0,0,.557,0c7.335-3.089,8.817-8.346,8.817-11.542V6.067a.717.717,0,0,0-.717-.717,13.577,13.577,0,0,1-7.91-3.165A.717.717,0,0,0,14.116,2Zm-.024,6.7a2.391,2.391,0,0,1,1.435,4.3v2.4a1.435,1.435,0,1,1-2.871,0v-2.4a2.391,2.391,0,0,1,1.435-4.3Z", transform: "translate(-5 -2)" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('privacySettingsTitle'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Privacy === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Appearance === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Appearance));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "18.07", height: "18.07", viewBox: "0 0 18.07 18.07" },
                        react_1.default.createElement("path", { id: "appearance", d: "M9.228,2A2.708,2.708,0,0,0,6.683,3.807H2.9a.9.9,0,1,0,0,1.807h3.78A2.706,2.706,0,1,0,9.228,2Zm5.421,1.807a.9.9,0,1,0,0,1.807h4.518a.9.9,0,1,0,0-1.807Zm-.9,4.518A2.708,2.708,0,0,0,11.2,10.132H2.9a.9.9,0,1,0,0,1.807h8.3a2.706,2.706,0,1,0,2.545-3.614Zm5.421,1.807a.9.9,0,1,0,.9.9.9.9,0,0,0-.9-.9ZM6.518,14.649a2.708,2.708,0,0,0-2.545,1.807H2.9a.9.9,0,1,0,0,1.807H3.973a2.706,2.706,0,1,0,2.545-3.614Zm5.421,1.807a.9.9,0,1,0,0,1.807h7.228a.9.9,0,1,0,0-1.807Z", transform: "translate(-2 -2)" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('appearanceSettingsTitle'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Appearance === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Notifications === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Notifications));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "20", viewBox: "0 0 16 20" },
                        react_1.default.createElement("path", { id: "notification", d: "M12,2a1.5,1.5,0,0,0-1.5,1.5v.7A6,6,0,0,0,6,10v6L4.465,17.156h0A1,1,0,0,0,5,19H19a1,1,0,0,0,.537-1.844L18,16V10a6,6,0,0,0-4.5-5.8V3.5A1.5,1.5,0,0,0,12,2ZM10,20a2,2,0,0,0,4,0Z", transform: "translate(-4 -2)" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('notificationsSettingsTitle'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Notifications === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Blocked === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Blocked));
                dispatch((0, userConfig_1.hideMultipleSelection)());
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "23.338", height: "23.281", viewBox: "0 0 23.338 23.281" },
                        react_1.default.createElement("path", { id: "blocked_contact", d: "M9.537.156C6.8.156,4.6,2.035,4.6,5.629a9.282,9.282,0,0,0,2.354,6.21c.553,1.471-.443,2.02-.652,2.1C3.44,14.987.094,16.894.094,18.787V19.5c0,2.58,4.913,3.176,9.471,3.176,1,0,2-.043,2.977-.113a7.05,7.05,0,0,1-.454-9.159,2.242,2.242,0,0,1,.057-1.588,9.249,9.249,0,0,0,2.325-6.182C14.471,2.035,12.273.156,9.537.156ZM17.7,11.981a5.728,5.728,0,1,0,5.728,5.728A5.728,5.728,0,0,0,17.7,11.981Zm-3.176,4.906h6.324v1.645H14.528Z", transform: "translate(-0.094 -0.156)" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('blockedSettingsTitle'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Blocked === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.RecoverySeed === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.RecoverySeed));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "19.648", height: "21.832", viewBox: "0 0 19.648 21.832" },
                        react_1.default.createElement("path", { id: "recovery_seed", d: "M20.465,3.184H15.9a3.255,3.255,0,0,0-6.147,0H5.184A2.182,2.182,0,0,0,3,5.366V20.648a2.182,2.182,0,0,0,2.184,2.184H20.465a2.182,2.182,0,0,0,2.184-2.184V5.366a2.182,2.182,0,0,0-2.184-2.182Zm-7.641,0a1.091,1.091,0,1,1-1.091,1.091A1.091,1.091,0,0,1,12.824,3.184Zm4.366,7.641H13.915v7.641H11.733V10.824H8.458V8.641h8.733Z", transform: "translate(-3 -1)" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('showRecoveryPhrase'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.RecoverySeed === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.MessageRequests === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.MessageRequests));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("i", { className: "left-pane-setting-category-list-item-icons" },
                    react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "23.205", height: "23.25", viewBox: "0 0 23.205 23.25" },
                        react_1.default.createElement("path", { id: "Message_request", d: "M8151.968-11515.188a1.833,1.833,0,0,1-1.827-1.827v-10.959a1.833,1.833,0,0,1,1.827-1.827h12.789l3.651-3.653-.009,16.439a1.825,1.825,0,0,1-1.818,1.827Zm6.393-2.739h1.827v-1.827h-1.827Zm1.827-6.283c0,.962-1.827,2.763-1.827,3.651h1.827c0-.9,1.827-2.354,1.827-3.651a2.714,2.714,0,0,0-2.739-2.741,2.755,2.755,0,0,0-2.739,2.741h1.824a.951.951,0,0,1,.915-.915A.9.9,0,0,1,8160.188-11524.211Zm-12.32,4.126a1.663,1.663,0,0,1-1.656-1.665l-.009-14.98,3.33,3.33h11.651a1.67,1.67,0,0,1,1.665,1.665v.109h-12.476a1.832,1.832,0,0,0-1.827,1.827v9.714Z", transform: "translate(-8145.703 11537.938)", stroke: "rgba(0,0,0,0)", strokeWidth: "1" }))),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, window.i18n('openMessageRequestInbox'))),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.MessageRequests === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 })))),
        react_1.default.createElement("div", { "data-testid": dataTestId, className: (0, classnames_1.default)('left-pane-setting-category-list-item', BchatSettings_1.BchatSettingCategory.Hops === focusedSettingsSection ? 'active' : ''), role: "link", onClick: () => {
                dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Hops));
            } },
            react_1.default.createElement("div", { style: { display: 'flex' } },
                react_1.default.createElement("span", { style: { padding: '0px 10px', marginRight: '11px' } },
                    ' ',
                    react_1.default.createElement(icon_1.BchatIcon, { iconType: "hops", iconSize: 'large', iconColor: "#01b700" })),
                react_1.default.createElement("span", { className: "left-pane-setting-category-list-item-span" }, "Hops")),
            react_1.default.createElement("div", null, BchatSettings_1.BchatSettingCategory.Hops === focusedSettingsSection && (react_1.default.createElement(icon_1.BchatIcon, { iconSize: "medium", iconType: "chevron", iconRotation: 270 }))))));
};
const LeftPaneSettingsCategories = () => {
    if (0) {
        LeftPaneSettingsCategoryRow;
    }
    return (react_1.default.createElement("div", { className: "module-left-pane__list", key: 0 },
        react_1.default.createElement("div", { className: "left-pane-setting-category-list" },
            react_1.default.createElement(LeftPaneSettingsCategoryRow, null))));
};
const LeftPaneBottomButtons = () => {
    const dangerButtonText = window.i18n('clearAllData');
    const dispatch = (0, react_redux_1.useDispatch)();
    return (react_1.default.createElement("div", { className: "left-pane-setting-bottom-buttons", key: 1 },
        react_1.default.createElement(BchatButton_1.BchatButton, { text: dangerButtonText, buttonType: BchatButton_1.BchatButtonType.SquareOutline, buttonColor: BchatButton_1.BchatButtonColor.Danger, onClick: () => {
                dispatch((0, modalDialog_1.updateDeleteAccountModal)({}));
            } })));
};
const LeftPaneSettingSection = () => {
    if (0) {
        LeftPaneBottomButtons;
    }
    return (react_1.default.createElement("div", { className: "left-pane-setting-section" },
        react_1.default.createElement(LeftPaneSectionHeader_1.LeftPaneSectionHeader, null),
        react_1.default.createElement("div", { className: "left-pane-setting-content" },
            react_1.default.createElement(LeftPaneSettingsCategories, null)),
        react_1.default.createElement("span", { className: "text-selectable", style: { color: '#797984', marginLeft: '20px', marginTop: '27px' } },
            window.i18n('BChat'),
            " v",
            window.getVersion()),
        react_1.default.createElement(LeftPaneBottomButtons, null)));
};
exports.LeftPaneSettingSection = LeftPaneSettingSection;
