"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConversationListItemHeaderItem = void 0;
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const styled_components_1 = __importDefault(require("styled-components"));
const useParamSelector_1 = require("../../../hooks/useParamSelector");
const section_1 = require("../../../state/ducks/section");
const search_1 = require("../../../state/selectors/search");
const section_2 = require("../../../state/selectors/section");
const Timestamp_1 = require("../../conversation/Timestamp");
const icon_1 = require("../../icon");
const ConversationListItem_1 = require("./ConversationListItem");
const UserItem_1 = require("./UserItem");
const NotificationSettingIcon = (props) => {
    const convoId = (0, react_1.useContext)(ConversationListItem_1.ContextConversationId);
    const convoSetting = (0, useParamSelector_1.useConversationPropsById)(convoId)?.currentNotificationSetting;
    if (!props.isMessagesSection) {
        return null;
    }
    switch (convoSetting) {
        case 'all':
            return null;
        case 'disabled':
            return (react_1.default.createElement(icon_1.BchatIcon, { iconType: "mute", iconColor: 'var(--color-text-subtle)', iconSize: "small" }));
        case 'mentions_only':
            return (react_1.default.createElement(icon_1.BchatIcon, { iconType: "bell", iconColor: 'var(--color-text-subtle)', iconSize: "small" }));
        default:
            return null;
    }
};
const StyledConversationListItemIconWrapper = styled_components_1.default.div `
  svg {
    margin: 0px 2px;
  }

  display: flex;
  flex-direction: row;
`;
function useHeaderItemProps(conversationId) {
    const convoProps = (0, useParamSelector_1.useConversationPropsById)(conversationId);
    if (!convoProps) {
        return null;
    }
    return {
        isPinned: !!convoProps.isPinned,
        mentionedUs: convoProps.mentionedUs || false,
        unreadCount: convoProps.unreadCount || 0,
        activeAt: convoProps.activeAt,
    };
}
const ListItemIcons = () => {
    const isMessagesSection = (0, react_redux_1.useSelector)(section_2.getFocusedSection) === section_1.SectionType.Message;
    const conversationId = (0, react_1.useContext)(ConversationListItem_1.ContextConversationId);
    const isPinned = (0, useParamSelector_1.useIsPinned)(conversationId);
    const pinIcon = isMessagesSection && isPinned ? (react_1.default.createElement(icon_1.BchatIcon, { iconType: "pin", iconColor: 'var(--color-text-subtle)', iconSize: "small" })) : null;
    return (react_1.default.createElement(StyledConversationListItemIconWrapper, null,
        pinIcon,
        react_1.default.createElement(NotificationSettingIcon, { isMessagesSection: isMessagesSection })));
};
const ConversationListItemHeaderItem = () => {
    const conversationId = (0, react_1.useContext)(ConversationListItem_1.ContextConversationId);
    const isSearchingMode = (0, react_redux_1.useSelector)(search_1.isSearching);
    const convoProps = useHeaderItemProps(conversationId);
    if (!convoProps) {
        return null;
    }
    const { unreadCount, activeAt } = convoProps;
    return (react_1.default.createElement("div", { className: "module-conversation-list-item__header" },
        react_1.default.createElement("div", { className: (0, classnames_1.default)('module-conversation-list-item__header__name', unreadCount > 0 ? 'module-conversation-list-item__header__name--with-unread' : null) },
            react_1.default.createElement(UserItem_1.UserItem, null)),
        react_1.default.createElement(ListItemIcons, null),
        react_1.default.createElement(Timestamp_1.Timestamp, { timestamp: activeAt, isConversationListItem: true, momentFromNow: true }),
        !isSearchingMode && (react_1.default.createElement("div", { className: (0, classnames_1.default)('module-conversation-list-item__header__date', unreadCount > 0 ? 'module-conversation-list-item__header__date--has-unread' : null) }))));
};
exports.ConversationListItemHeaderItem = ConversationListItemHeaderItem;
