"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverlayClosedGroup = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const BchatIdEditable_1 = require("../../basic/BchatIdEditable");
const BchatSpinner_1 = require("../../basic/BchatSpinner");
const MemberListItem_1 = require("../../MemberListItem");
const section_1 = require("../../../state/ducks/section");
const conversations_1 = require("../../../state/selectors/conversations");
const Text_1 = require("../../basic/Text");
const MainViewController_1 = require("../../MainViewController");
const useKey_1 = __importDefault(require("react-use/lib/useKey"));
const LeftPaneSectionHeader_1 = require("../LeftPaneSectionHeader");
const OverlayClosedGroup = () => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const privateContactsPubkeys = (0, react_redux_1.useSelector)(conversations_1.getPrivateContactsPubkeys);
    const [groupName, setGroupName] = (0, react_1.useState)('');
    const [loading, setLoading] = (0, react_1.useState)(false);
    const [selectedMemberIds, setSelectedMemberIds] = (0, react_1.useState)([]);
    function closeOverlay() {
        dispatch((0, section_1.setOverlayMode)(undefined));
    }
    function handleSelectMember(memberId) {
        if (selectedMemberIds.includes(memberId)) {
            return;
        }
        setSelectedMemberIds([...selectedMemberIds, memberId]);
    }
    function handleUnselectMember(unselectId) {
        setSelectedMemberIds(selectedMemberIds.filter(id => {
            return id !== unselectId;
        }));
    }
    async function onEnterPressed() {
        if (loading) {
            window?.log?.warn('Closed group creation already in progress');
            return;
        }
        setLoading(true);
        const groupCreated = await MainViewController_1.MainViewController.createClosedGroup(groupName, selectedMemberIds);
        if (groupCreated) {
            closeOverlay();
            dispatch((0, section_1.showLeftPaneSection)(0));
            dispatch((0, section_1.setOverlayMode)(undefined));
            return;
        }
        setLoading(false);
    }
    (0, useKey_1.default)('Escape', closeOverlay);
    const title = window.i18n('newSecretGroup');
    const subtitle = window.i18n('createSecretGroupNamePrompt');
    const placeholder = window.i18n('createSecretGroupPlaceholder');
    const noContactsForClosedGroup = privateContactsPubkeys.length === 0;
    function addContact() {
        dispatch((0, section_1.showLeftPaneSection)(0));
        window.inboxStore?.dispatch((0, section_1.setOverlayMode)('message'));
    }
    return (react_1.default.createElement("div", { className: "module-left-pane-overlay" },
        react_1.default.createElement(LeftPaneSectionHeader_1.LeftPaneSectionHeader, null),
        react_1.default.createElement("div", { style: { height: 'calc(100% - 222px)', overflowY: 'auto' } },
            react_1.default.createElement("div", { className: "module-left-pane-overlay-closed--header" }, title),
            !noContactsForClosedGroup && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: "module-left-pane-overlay-closed--subHeader" }, subtitle),
                react_1.default.createElement("div", { className: "create-group-name-input" },
                    react_1.default.createElement(BchatIdEditable_1.BchatIdEditable, { editable: !noContactsForClosedGroup, placeholder: placeholder, value: groupName, isGroup: true, maxLength: 32, onChange: setGroupName, onPressEnter: onEnterPressed, dataTestId: "new-closed-group-name" })))),
            react_1.default.createElement(Text_1.SpacerLG, null),
            loading ? (react_1.default.createElement(BchatSpinner_1.BchatSpinner, { loading: loading })) : (react_1.default.createElement("div", { className: "group-member-list__container" }, noContactsForClosedGroup ? (react_1.default.createElement("div", { className: "group-member-list__no-contacts" },
                react_1.default.createElement("div", { className: "group-member-list__addImg" }),
                react_1.default.createElement("h4", { className: "module-left-pane__empty_contact" }, window.i18n('noContactsYet')),
                react_1.default.createElement("div", { style: { display: 'flex' } },
                    react_1.default.createElement("button", { className: "nextButton", style: { width: '90%' }, onClick: () => addContact() },
                        "Add Contacts +",
                        ' ')))) : (react_1.default.createElement("div", { className: "group-member-list__selection" }, privateContactsPubkeys.map((memberPubkey) => (react_1.default.createElement(MemberListItem_1.MemberListItem, { pubkey: memberPubkey, isSelected: selectedMemberIds.some(m => m === memberPubkey), key: memberPubkey, onSelect: selectedMember => {
                    handleSelectMember(selectedMember);
                }, onUnselect: unselectedMember => {
                    handleUnselectMember(unselectedMember);
                } }))))))),
            react_1.default.createElement(Text_1.SpacerLG, null)),
        !noContactsForClosedGroup && (react_1.default.createElement("div", { className: "buttonBox" },
            react_1.default.createElement("button", { className: "nextButton", onClick: onEnterPressed }, "Create")))));
};
exports.OverlayClosedGroup = OverlayClosedGroup;
