"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverlayMessage = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const BchatIdEditable_1 = require("../../basic/BchatIdEditable");
const BchatSpinner_1 = require("../../basic/BchatSpinner");
const section_1 = require("../../../state/ducks/section");
const types_1 = require("../../../bchat/types");
const conversation_1 = require("../../../models/conversation");
const snode_api_1 = require("../../../bchat/apis/snode_api");
const conversations_1 = require("../../../bchat/conversations");
const conversations_2 = require("../../../state/ducks/conversations");
const useKey_1 = __importDefault(require("react-use/lib/useKey"));
const user_1 = require("../../../state/selectors/user");
const utils_1 = require("../../../bchat/utils");
const OverlayMessage = () => {
    const dispatch = (0, react_redux_1.useDispatch)();
    function closeOverlay() {
        dispatch((0, section_1.setOverlayMode)(undefined));
    }
    (0, useKey_1.default)('Escape', closeOverlay);
    const [pubkeyOrOns, setPubkeyOrOns] = (0, react_1.useState)('');
    const [loading, setLoading] = (0, react_1.useState)(false);
    const ourNumber = (0, react_redux_1.useSelector)(user_1.getOurNumber);
    const buttonText = window.i18n('next');
    const descriptionLong = window.i18n('shareBchatIdDiscription');
    const placeholder = window.i18n('enterBchatID');
    async function handleMessageButtonClick() {
        const pubkeyorOnsTrimmed = pubkeyOrOns.trim();
        if (!pubkeyOrOns || pubkeyOrOns.length !== 66) {
            utils_1.ToastUtils.pushToastError('invalidPubKey', window.i18n('invalidNumberError'));
            return;
        }
        if (!types_1.PubKey.validateWithError(pubkeyorOnsTrimmed)) {
            await (0, conversations_1.getConversationController)().getOrCreateAndWait(pubkeyorOnsTrimmed, conversation_1.ConversationTypeEnum.PRIVATE);
            await (0, conversations_2.openConversationWithMessages)({ conversationKey: pubkeyorOnsTrimmed, messageId: null });
            closeOverlay();
        }
        else {
            setLoading(true);
            try {
                const resolvedBchatID = await snode_api_1.SNodeAPI.getBchatIDForOnsName(pubkeyorOnsTrimmed);
                if (types_1.PubKey.validateWithError(resolvedBchatID)) {
                    throw new Error('Got a resolved BNS but the returned entry is not a valid bchatID');
                }
                await (0, conversations_1.getConversationController)().getOrCreateAndWait(resolvedBchatID, conversation_1.ConversationTypeEnum.PRIVATE);
                await (0, conversations_2.openConversationWithMessages)({ conversationKey: resolvedBchatID, messageId: null });
                closeOverlay();
            }
            catch (e) {
                window?.log?.warn('failed to resolve bns name', pubkeyorOnsTrimmed, e);
            }
            finally {
                setLoading(false);
            }
        }
    }
    return (react_1.default.createElement("div", { className: "module-left-pane-overlay" },
        react_1.default.createElement("p", { className: 'module-left-pane__chatHeader' }, window.i18n('startConversation')),
        react_1.default.createElement("p", { className: "module-left-pane__subHeader" }, window.i18n('BchatID')),
        react_1.default.createElement("div", { className: "bchat-description-long" }, descriptionLong),
        react_1.default.createElement(BchatIdEditable_1.BchatIdEditable, { editable: !loading, placeholder: placeholder, onChange: setPubkeyOrOns, dataTestId: "new-bchat-conversation" }),
        react_1.default.createElement(BchatSpinner_1.BchatSpinner, { loading: loading }),
        react_1.default.createElement("p", { className: "module-left-pane__subHeader", style: { marginBottom: "10px" } }, "Your BChat ID"),
        react_1.default.createElement("div", { className: "bchat-description-long" }, "Share your BChat ID with your friends. You can find your BChat ID below"),
        react_1.default.createElement(BchatIdEditable_1.BchatIdEditable, { value: ourNumber, dataTestId: "new-bchat-conversation" }),
        react_1.default.createElement("button", { className: 'nextButton', onClick: handleMessageButtonClick }, buttonText)));
};
exports.OverlayMessage = OverlayMessage;
