"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DisplaySeed = exports.ClearIcon = exports.Icons = void 0;
const react_1 = __importDefault(require("react"));
const BchatButton_1 = require("../basic/BchatButton");
const ActionsPanel_1 = require("../leftpane/ActionsPanel");
const Icons = (props) => (react_1.default.createElement("div", { onClick: () => props.iconfunc(), className: "paste-icon", "data-tip": "Paste", "data-offset": "{'top':30,'left':15}", "data-place": "right", style: {} },
    react_1.default.createElement("img", { src: "images/bchat/paste.svg", width: 20, height: 20 })));
exports.Icons = Icons;
const ClearIcon = (props) => (react_1.default.createElement("div", { onClick: () => props.removeRecoveryPhrase(), "data-tip": "Clear", "data-place": "top", className: "paste-icon", "data-offset": "{'right':35,'left':5}", style: {
        background: `url(images/bchat/clear.svg) no-repeat`,
        width: '10px',
        height: '10px',
        position: 'relative',
        top: '8px',
        marginLeft: '408px',
        cursor: 'pointer',
        backgroundSize: 'cover',
    } }));
exports.ClearIcon = ClearIcon;
const handlePaste = (event) => {
    event.clipboardData.getData('text');
};
const DisplaySeed = (props) => (react_1.default.createElement("div", { className: "bchat-restore-seed__address-container" },
    react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "bchat-registration-header" }, window.i18n('restoreFromSeed')),
        react_1.default.createElement("div", { className: "bchat-restore-seed-parent-box" },
            react_1.default.createElement("div", { className: "bchat-restore-seed-text-box" },
                react_1.default.createElement(exports.ClearIcon, { removeRecoveryPhrase: () => props.assignRecoveryPhase('') }),
                react_1.default.createElement("textarea", { className: "bchat-restore-seed-text-area", name: "text", onPaste: handlePaste, value: props.recoveryPhrase, placeholder: "Enter your recovery seed to restore your account", onChange: e => props.assignRecoveryPhase(e.target.value) })),
            react_1.default.createElement("div", { className: "bchat-restore-seed-icon-box" }, react_1.default.createElement(exports.Icons, { icon: 'paste', iconfunc: props.iconfunc })))),
    react_1.default.createElement("div", { style: { width: '95.5%' } },
        react_1.default.createElement(BchatButton_1.BchatButton, { onClick: props.onNext, buttonType: BchatButton_1.BchatButtonType.Brand, buttonColor: BchatButton_1.BchatButtonColor.Green, text: window.i18n('next') })),
    react_1.default.createElement(ActionsPanel_1.BchatToolTip, { effect: "solid" })));
exports.DisplaySeed = DisplaySeed;
