"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatRecoverySeed = void 0;
const react_1 = __importDefault(require("react"));
const BchatSeedModal_1 = require("../dialog/BchatSeedModal");
const react_redux_1 = require("react-redux");
const modal_1 = require("../../state/selectors/modal");
const BchatButton_1 = require("../basic/BchatButton");
const icon_1 = require("../icon");
const BchatSettings_1 = require("./BchatSettings");
const section_1 = require("../../state/ducks/section");
const CategoryPrivacy_1 = require("./section/CategoryPrivacy");
const Text_1 = require("../basic/Text");
const BchatRecoverySeed = (props) => {
    const recoveryPhraseModalState = (0, react_redux_1.useSelector)(modal_1.getRecoveryPhraseDialog);
    if (props.passwordLock) {
        return react_1.default.createElement(BchatSeedModal_1.BchatSeedModal, { ...recoveryPhraseModalState });
    }
    return (react_1.default.createElement("div", { className: "bchat-settings-warnUnsetpass" },
        react_1.default.createElement("div", { className: "bchat-settings-warnUnsetpass-contentbox" },
            react_1.default.createElement(icon_1.BchatIcon, { iconType: "info", iconSize: 60, iconColor: "#2879FB" }),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: "fontSemiBold" }, window.i18n('setPassword')),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", null,
                "Set a Password before accessing the Recovery Phrase. You can set your password from",
                ' '),
            react_1.default.createElement("div", { className: "fontSemiBold" }, "Settings -> Privacy -> Set Account Password."),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: 'flexCenter' },
                react_1.default.createElement(BchatButton_1.BchatButton, { text: 'OK', onClick: () => {
                        window.inboxStore?.dispatch((0, section_1.showSettingsSection)(BchatSettings_1.BchatSettingCategory.Privacy));
                        (0, CategoryPrivacy_1.displayPasswordModal)('set', props.onPasswordUpdated);
                    }, buttonType: BchatButton_1.BchatButtonType.Brand, buttonColor: BchatButton_1.BchatButtonColor.Green })))));
};
exports.BchatRecoverySeed = BchatRecoverySeed;
