"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingsHeader = void 0;
const react_1 = __importDefault(require("react"));
const Avatar_1 = require("../avatar/Avatar");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const react_redux_1 = require("react-redux");
const user_1 = require("../../state/selectors/user");
const BchatIconButton_1 = require("../icon/BchatIconButton");
const userConfig_1 = require("../../state/ducks/userConfig");
const userConfig_2 = require("../../state/selectors/userConfig");
const SettingsHeader = (props) => {
    const { categoryTitle } = props;
    const dispatch = (0, react_redux_1.useDispatch)();
    const ourNumber = (0, react_redux_1.useSelector)(user_1.getOurNumber);
    const multipleSelectionValue = (0, react_redux_1.useSelector)(userConfig_2.getMultipleSelection);
    return (react_1.default.createElement("div", { className: "bchat-settings-header" },
        react_1.default.createElement("div", { style: { paddingLeft: '15px' } },
            react_1.default.createElement(Avatar_1.Avatar, { size: Avatar_1.AvatarSize.M, onAvatarClick: () => dispatch((0, modalDialog_1.editProfileModal)({})), pubkey: ourNumber, dataTestId: "leftpane-primary-avatar" })),
        react_1.default.createElement("div", { className: "bchat-settings-header-title" }, categoryTitle),
        window.i18n('blockedSettingsTitle') === categoryTitle &&
            react_1.default.createElement("div", { className: 'bchat-settings-header-selectionBox' }, multipleSelectionValue ?
                react_1.default.createElement(BchatIconButton_1.BchatIconButton, { iconSize: "medium", iconType: "markAllDone", onClick: () => { dispatch((0, userConfig_1.toggleMultipleSelection)()); } })
                :
                    react_1.default.createElement(BchatIconButton_1.BchatIconButton, { iconSize: "medium", iconType: "markAll", onClick: () => { dispatch((0, userConfig_1.toggleMultipleSelection)()); } }))));
};
exports.SettingsHeader = SettingsHeader;
