"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddressBook = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const classnames_1 = __importDefault(require("classnames"));
const walletConfig_1 = require("../../state/ducks/walletConfig");
const walletInnerSection_1 = require("../../state/ducks/walletInnerSection");
const walletSection_1 = require("../../state/ducks/walletSection");
const conversations_1 = require("../../state/selectors/conversations");
const Flex_1 = require("../basic/Flex");
const Text_1 = require("../basic/Text");
const EditProfileDialog_1 = require("../dialog/EditProfileDialog");
const icon_1 = require("../icon");
const useParamSelector_1 = require("../../hooks/useParamSelector");
const LeftPaneSectionHeader_1 = require("../leftpane/LeftPaneSectionHeader");
const Avatar_1 = require("../avatar/Avatar");
const modal_1 = require("../../state/selectors/modal");
const AddressBook = (props) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const privateContactsPubkeys = (0, react_redux_1.useSelector)(conversations_1.getPrivateContactsPubkeys);
    const BchatWalletPasswordModal = (0, react_redux_1.useSelector)(modal_1.getBchatWalletPasswordModal);
    async function copyBtn(address) {
        (0, EditProfileDialog_1.copyBchatID)(address);
    }
    async function send(address) {
        dispatch((0, walletSection_1.dashboard)());
        dispatch((0, walletInnerSection_1.walletSendPage)());
        dispatch((0, walletConfig_1.updateSendAddress)(address));
    }
    const AddressContent = (props) => {
        const username = (0, useParamSelector_1.useConversationUsernameOrShorten)(props.pubkey);
        const belAddress = (0, useParamSelector_1.useConversationBeldexAddress)(props.pubkey);
        return belAddress ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: (0, classnames_1.default)(`addressBook-wholeBox-contentBox`), style: window.i18n('addressBook') !== props.title ? { cursor: 'pointer' } : {}, onClick: () => window.i18n('addressBook') !== props.title ? send(belAddress) : dispatch((0, walletConfig_1.updateSendAddress)(belAddress)) },
                props.title === window.i18n('contact') &&
                    react_1.default.createElement("div", { className: 'avatarBox' },
                        " ",
                        react_1.default.createElement(Avatar_1.Avatar, { size: Avatar_1.AvatarSize.M, pubkey: props.pubkey })),
                react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "column" },
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("span", { className: (0, classnames_1.default)("addressBook-wholeBox-contentBox-nameBtn", props.title === window.i18n('contact') && 'contact') }, username)),
                    react_1.default.createElement(Text_1.SpacerXS, null),
                    react_1.default.createElement("div", { className: "addressBook-wholeBox-contentBox-addresstxt", style: { cursor: 'pointer' }, onClick: () => { dispatch((0, walletConfig_1.updateSendAddress)(belAddress)); dispatch((0, walletInnerSection_1.walletSendPage)()); } }, props.title === window.i18n('contact') ? belAddress.slice(0, 70) + '...' : belAddress)),
                window.i18n('addressBook') === props.title && (react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "row", alignItems: "center" },
                    react_1.default.createElement("div", { className: "addressBook-wholeBox-contentBox-sendBtn", onClick: () => send(belAddress) },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: "send", iconSize: 'small' }),
                        react_1.default.createElement("span", { style: { marginLeft: "3px" } }, window.i18n('send'))),
                    react_1.default.createElement("div", { className: "addressBook-wholeBox-contentBox-copyBtn", onClick: () => copyBtn(belAddress) },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: "copy", iconSize: 'small' }),
                        react_1.default.createElement("span", { style: { marginLeft: '3px' } }, window.i18n('editMenuCopy')))))),
            react_1.default.createElement(Text_1.SpacerXS, null))) : (react_1.default.createElement(react_1.default.Fragment, null));
    };
    return (react_1.default.createElement("div", { className: "addressBook" },
        props.from === window.i18n('contact') && react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(LeftPaneSectionHeader_1.LeftPaneSectionHeader, null),
            react_1.default.createElement("div", { className: "addressBook-header-txt" }, window.i18n('contact'))),
        props.from !== window.i18n('contact') &&
            react_1.default.createElement("div", { style: { cursor: 'pointer' } },
                react_1.default.createElement(Flex_1.Flex, { container: true, alignItems: "center" },
                    react_1.default.createElement("div", { onClick: () => dispatch((0, walletSection_1.dashboard)()) },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: "walletBackArrow", iconSize: 'huge', iconColor: '#9393af' })),
                    react_1.default.createElement("div", { className: "addressBook-header-txt" }, props.from))),
        react_1.default.createElement(Text_1.SpacerLG, null),
        react_1.default.createElement("div", { className: (0, classnames_1.default)("addressBook-wholeBox ", BchatWalletPasswordModal && 'blurBg') },
            privateContactsPubkeys.length > 0 &&
                privateContactsPubkeys.map(item => react_1.default.createElement(AddressContent, { pubkey: item, title: props.from })),
            privateContactsPubkeys.length == 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: "addressBook-emptyAddressBook" }),
                react_1.default.createElement("h4", { className: "addressBook-emptyAddressBook-content" },
                    window.i18n('addressBook') !== props.from
                        ? window.i18n('emptyContact')
                        : window.i18n('emptyAddressBook'),
                    react_1.default.createElement("span", { style: { marginLeft: '7px' } },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: 'sadEmoji', iconSize: 'small', iconColor: '#646474' }))))) : (''))));
};
exports.AddressBook = AddressBook;
