"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WalletBalanceSection = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const utils_1 = require("../../bchat/utils");
const walletConfig_1 = require("../../state/selectors/walletConfig");
const Text_1 = require("../basic/Text");
const BchatIcon_1 = require("../icon/BchatIcon");
const ActionsPanel_1 = require("../leftpane/ActionsPanel");
const settings_key_1 = require("../../data/settings-key");
const { clipboard } = require('electron');
const WalletBalanceSection = () => {
    const walletDetails = (0, react_redux_1.useSelector)((state) => state.wallet);
    const walletAddress = localStorage.getItem('userAddress');
    const sliceWalletAddress = walletAddress ? walletAddress.slice(0, 45) : '';
    const currency = window.getSettingValue(settings_key_1.walletSettingsKey.settingsFiatCurrency);
    const fiatBalance = Number((0, react_redux_1.useSelector)(walletConfig_1.getFiatBalance));
    const [amountVisible, setAmountVisible] = (0, react_1.useState)(window.getSettingValue('balancevisibility'));
    const zoomLevel = window.getSettingValue('zoom-factor-setting');
    let decimalValue = window.getSettingValue(settings_key_1.walletSettingsKey.settingsDecimal) || '2 - Two (0.00)';
    decimalValue = decimalValue.charAt(0);
    const handlePaste = () => {
        clipboard.writeText(walletAddress, 'clipboard');
        utils_1.ToastUtils.pushCopiedToClipBoard();
    };
    function disableBalac(values) {
        if (amountVisible) {
            return values;
        }
        let txt = String(values);
        let sliptStr = txt.split('');
        let dataArray = '';
        sliptStr.length > 0 &&
            sliptStr.map((item) => {
                if (item === '.') {
                    dataArray = dataArray + '.';
                    return;
                }
                dataArray = dataArray + '*';
            });
        return dataArray;
    }
    return (react_1.default.createElement("div", { className: "wallet-squarBox-bala", style: zoomLevel > 100 ? { width: '52%' } : {} },
        react_1.default.createElement("div", { className: "flexCenter" },
            react_1.default.createElement(BchatIcon_1.BchatIcon, { iconSize: 13, iconType: "wallet" }),
            react_1.default.createElement("span", { className: "marginLeft" }, "Balance")),
        react_1.default.createElement("div", { className: 'flexWrap' },
            react_1.default.createElement("div", { className: "wallet-left-balance-Sec" },
                react_1.default.createElement(Text_1.SpacerXS, null),
                react_1.default.createElement(Text_1.SpacerSM, null),
                react_1.default.createElement("div", { className: "wallet-left-balance-Sec-balanceTxt" },
                    disableBalac((walletDetails.balance / 1e9).toFixed(decimalValue)),
                    ' ',
                    react_1.default.createElement("span", { className: "marginRight", style: { color: '#128b17' } }, "BDX"),
                    react_1.default.createElement("span", { onClick: () => {
                            setAmountVisible(!amountVisible);
                            window.setSettingValue('balancevisibility', !amountVisible);
                        }, style: { cursor: 'pointer' } },
                        react_1.default.createElement(BchatIcon_1.BchatIcon, { iconSize: "small", iconType: !amountVisible ? 'eye' : 'eye_closed' }))),
                react_1.default.createElement("div", { className: "wallet-left-balance-Sec-fiatCurrency" },
                    disableBalac((fiatBalance / 1e9).toFixed(decimalValue)),
                    " ",
                    react_1.default.createElement("span", null, currency))),
            react_1.default.createElement("div", { className: "wallet-right-Button-Sec" },
                react_1.default.createElement(Text_1.SpacerXS, null),
                react_1.default.createElement(Text_1.SpacerSM, null),
                react_1.default.createElement("div", { className: "wallet-myAddress-Box" },
                    react_1.default.createElement("div", { className: "wallet-myAddress-Box-content" }, `${sliceWalletAddress}...`),
                    react_1.default.createElement("div", { className: "wallet-myAddress-Box-copyIcon-box", onClick: handlePaste, "data-tip": "Copy", "data-place": "right", "data-offset": "{'top':30,'left':15}" },
                        react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "14", height: "14", viewBox: "0 0 18.151 18.151" },
                            react_1.default.createElement("path", { id: "copy_icon", d: "M3.815,2A1.815,1.815,0,0,0,2,3.815V16.521H3.815V3.815H16.521V2Zm3.63,3.63A1.815,1.815,0,0,0,5.63,7.445V18.336a1.815,1.815,0,0,0,1.815,1.815H18.336a1.815,1.815,0,0,0,1.815-1.815V7.445A1.815,1.815,0,0,0,18.336,5.63Zm0,1.815H18.336V18.336H7.445Z", transform: "translate(-2 -2)" }))),
                    react_1.default.createElement(ActionsPanel_1.BchatToolTip, { place: "top", effect: "solid" })))),
        react_1.default.createElement(Text_1.SpacerMD, null),
        react_1.default.createElement("div", { className: "wallet-right-Button-Sec-unlockbal-box" },
            react_1.default.createElement("div", null,
                react_1.default.createElement("span", { className: "wallet-right-Button-Sec-unlockbal-box--Text" }, "Unlocked Balance"),
                react_1.default.createElement("span", { className: "wallet-right-Button-Sec-unlockbal-box--verticalLine" }),
                react_1.default.createElement("span", { className: "unBalance" }, disableBalac((walletDetails.unlocked_balance / 1e9).toFixed(decimalValue)))),
            react_1.default.createElement("div", { className: 'bdx' }, "BDX"))));
};
exports.WalletBalanceSection = WalletBalanceSection;
