"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChangePassword = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const utils_1 = require("../../bchat/utils");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const BchatButton_1 = require("../basic/BchatButton");
const Flex_1 = require("../basic/Flex");
const Text_1 = require("../basic/Text");
const BchatWrapperModal_1 = require("../BchatWrapperModal");
const icon_1 = require("../icon");
const wallet_rpc_1 = require("../../wallet/wallet-rpc");
const react_use_1 = require("react-use");
const styled_components_1 = __importDefault(require("styled-components"));
const ChangePassword = () => {
    const [oldPassword, setOldPassword] = (0, react_1.useState)('');
    const [newPassword, setNewPassword] = (0, react_1.useState)('');
    const [confirmPassword, setConfirmNewPassword] = (0, react_1.useState)('');
    const [newPasswordVisible, setNewPasswordVisible] = (0, react_1.useState)(true);
    const [confirmPasswordVisible, setConfirmNewPasswordVisible] = (0, react_1.useState)(true);
    const [loading, setLoading] = (0, react_1.useState)(false);
    const dispatch = (0, react_redux_1.useDispatch)();
    function onClickCancelHandler() {
        setLoading(false);
        dispatch((0, modalDialog_1.ChangePasswordModal)(null));
    }
    const Loader = styled_components_1.default.div `
    position: absolute;
    // top: 0;
    display: flex;
    // justify-content: center;
    /* width: 100%; */
    // width: 100Vw;
    // height: 100%;
    align-items: center;
    z-index: 101;
  `;
    const passValid = async () => {
        if (!oldPassword || !newPassword || !confirmPassword) {
            return utils_1.ToastUtils.pushToastError('passwordFieldEmpty', window.i18n('passwordFieldEmpty'));
        }
        if (newPassword !== confirmPassword) {
            return utils_1.ToastUtils.pushToastError('invalidPassword', 'Passwords do not match');
        }
        if (oldPassword == newPassword) {
            window?.log?.warn('invalid password');
            return utils_1.ToastUtils.pushToastError('oldPasswordSame', `Cannot use old password. Set a different password.`);
        }
        if ((newPassword.length < 4 && confirmPassword.length < 4) ||
            (newPassword.length > 13 && confirmPassword.length > 13)) {
            return utils_1.ToastUtils.pushToastError('walletPasswordLengthError', window.i18n('walletPasswordLengthError'));
        }
        setLoading(true);
        const changePassword = await wallet_rpc_1.wallet.changeWalletPassword(oldPassword, newPassword);
        if (changePassword.hasOwnProperty('error')) {
            setLoading(false);
            return utils_1.ToastUtils.pushToastError('changePasswordError', changePassword.error.message);
        }
        wallet_rpc_1.wallet.wallet_state.password_hash = wallet_rpc_1.wallet.passwordEncrypt(newPassword);
        setLoading(false);
        utils_1.ToastUtils.pushToastSuccess('changePasswordSuccess', 'Password successfully changed.');
        return onClickCancelHandler();
    };
    (0, react_use_1.useKey)((event) => {
        return event.key === 'Enter';
    }, passValid);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(BchatWrapperModal_1.BchatWrapperModal, { onClose: () => onClickCancelHandler(), showExitIcon: false, headerReverse: true, showHeader: false },
            loading && react_1.default.createElement(Loader, null,
                react_1.default.createElement("div", { className: 'edit-profile-dialog-modalLoader', style: {
                        width: '524px',
                        height: '375px'
                    } },
                    react_1.default.createElement("img", { src: "images/bchat/Load_animation.gif", style: { width: "150px", height: '150px' } }))),
            react_1.default.createElement("div", { className: 'walletChangePasswordHeader' }, window.i18n('changePassword')),
            react_1.default.createElement("div", { className: "bchat-modal__centered changepass", style: { width: '475px', alignItems: 'start' } },
                react_1.default.createElement(Text_1.SpacerMD, null),
                react_1.default.createElement("span", { className: 'changepass-oldpassInput' },
                    react_1.default.createElement("input", { value: oldPassword, onChange: e => {
                            setOldPassword(e.target.value);
                        }, placeholder: window.i18n('currentPassword') })),
                react_1.default.createElement(Text_1.SpacerMD, null),
                react_1.default.createElement("div", null, window.i18n('changewalletPassword')),
                react_1.default.createElement(Text_1.SpacerSM, null),
                react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: 'row', alignItems: "center", width: "100%" },
                    react_1.default.createElement("span", { className: 'changepass-newPassInput' },
                        react_1.default.createElement("input", { value: newPassword, onChange: e => {
                                setNewPassword(e.target.value);
                            }, placeholder: window.i18n('enterPassword'), type: newPasswordVisible ? "password" : "text", maxLength: 13 })),
                    react_1.default.createElement("span", { onClick: () => setNewPasswordVisible(!newPasswordVisible), style: { cursor: 'pointer' } },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: !newPasswordVisible ? "eye_closed" : "eye", iconSize: 'medium' }))),
                react_1.default.createElement(Text_1.SpacerSM, null),
                react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: 'row', alignItems: "center", width: "100%" },
                    react_1.default.createElement("span", { className: 'changepass-newPassInput' },
                        react_1.default.createElement("input", { value: confirmPassword, onChange: e => {
                                setConfirmNewPassword(e.target.value);
                            }, placeholder: window.i18n('confirmPassword'), type: confirmPasswordVisible ? "password" : "text", maxLength: 13 })),
                    react_1.default.createElement("span", { onClick: () => setConfirmNewPasswordVisible(!confirmPasswordVisible), style: { cursor: 'pointer' } },
                        react_1.default.createElement(icon_1.BchatIcon, { iconType: !confirmPasswordVisible ? "eye_closed" : "eye", iconSize: 'medium' })))),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: "wallet-settings-modalBtnGrp" },
                react_1.default.createElement("div", { className: "bchat-modal__button-group__center" },
                    react_1.default.createElement(BchatButton_1.BchatButton, { text: window.i18n('cancel'), buttonType: BchatButton_1.BchatButtonType.BrandOutline, buttonColor: BchatButton_1.BchatButtonColor.Primary, onClick: onClickCancelHandler }),
                    react_1.default.createElement(BchatButton_1.BchatButton, { text: window.i18n('save'), buttonType: BchatButton_1.BchatButtonType.BrandOutline, buttonColor: BchatButton_1.BchatButtonColor.Green, onClick: passValid }))))));
};
exports.ChangePassword = ChangePassword;
