"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BalanceAndsendReceiveAction = exports.Dashboard = exports.WalletMainPanel = exports.WalletDashboard = exports.WalletPage = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const Flex_1 = require("../basic/Flex");
const Text_1 = require("../basic/Text");
const BchatWalletAddressBook_1 = require("./BchatWalletAddressBook");
const BchatWalletBalanceSection_1 = require("./BchatWalletBalanceSection");
const BchatWalletHeader_1 = require("./BchatWalletHeader");
const BchatWalletNodeSetting_1 = require("./BchatWalletNodeSetting");
const BchatWalletPaymentSection_1 = require("./BchatWalletPaymentSection");
const BchatWalletReceivedForm_1 = require("./BchatWalletReceivedForm");
const BchatWalletSettings_1 = require("./BchatWalletSettings");
const BchatWalletSendForm_1 = require("./BchatWalletSendForm");
const BchatWalletTransactionSection_1 = require("./BchatWalletTransactionSection");
const BchatWalletSyncSatusBar_1 = require("./BchatWalletSyncSatusBar");
const walletConfig_1 = require("../../state/ducks/walletConfig");
const utils_1 = require("../../bchat/utils");
const classnames_1 = __importDefault(require("classnames"));
const modal_1 = require("../../state/selectors/modal");
var WalletPage;
(function (WalletPage) {
    WalletPage["WalletPassword"] = "walletPassword";
    WalletPage["Dashboard"] = "dashboard";
    WalletPage["AddressBook"] = "addressbook";
    WalletPage["Setting"] = "setting";
    WalletPage["NodeSetting"] = "nodeSetting";
    WalletPage["Contact"] = "contact";
})(WalletPage = exports.WalletPage || (exports.WalletPage = {}));
var WalletDashboard;
(function (WalletDashboard) {
    WalletDashboard["walletSend"] = "walletSend";
    WalletDashboard["walletReceived"] = "walletReceived";
    WalletDashboard["walletTransaction"] = "walletTransaction";
})(WalletDashboard = exports.WalletDashboard || (exports.WalletDashboard = {}));
const WalletMainPanel = () => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const focusedsettings = (0, react_redux_1.useSelector)((state) => state.walletFocused);
    const [amount, setAmount] = (0, react_1.useState)('');
    const [notes, setNotes] = (0, react_1.useState)('');
    const BchatWalletPasswordModal = (0, react_redux_1.useSelector)(modal_1.getBchatWalletPasswordModal);
    if (!window.globalOnlineStatus) {
        utils_1.ToastUtils.pushToastError('internetConnectionError', 'Please check your internet connection');
    }
    function numberOnly(e) {
        const re = /^\d+\.?\d*$/;
        if (e === '' || re.test(e)) {
            setAmount(e);
        }
    }
    function clearStates() {
        setAmount("");
        setNotes("");
        let emptyAddress = '';
        dispatch((0, walletConfig_1.updateSendAddress)(emptyAddress));
    }
    if (WalletPage.AddressBook === focusedsettings) {
        return (react_1.default.createElement("div", { className: "wallet" },
            react_1.default.createElement(BchatWalletAddressBook_1.AddressBook, { from: window.i18n('addressBook') })));
    }
    if (WalletPage.Contact === focusedsettings) {
        return (react_1.default.createElement("div", { className: "wallet" },
            react_1.default.createElement(BchatWalletAddressBook_1.AddressBook, { from: window.i18n('contact') })));
    }
    if (WalletPage.Setting === focusedsettings) {
        return (react_1.default.createElement("div", { className: "wallet" },
            react_1.default.createElement(BchatWalletSettings_1.WalletSettings, null)));
    }
    if (WalletPage.NodeSetting === focusedsettings) {
        return (react_1.default.createElement("div", { className: "wallet" },
            react_1.default.createElement(BchatWalletNodeSetting_1.NodeSetting, null)));
    }
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)("wallet", BchatWalletPasswordModal && 'blurBg') },
        react_1.default.createElement(exports.Dashboard, { amount: amount, setAmount: (e) => {
                numberOnly(e);
            }, notes: notes, setNotes: (e) => setNotes(e), clearStates: () => clearStates() })));
};
exports.WalletMainPanel = WalletMainPanel;
const Dashboard = (props) => {
    const focusedInnersection = (0, react_redux_1.useSelector)((state) => state.walletInnerFocused);
    let transactions = (0, react_redux_1.useSelector)((state) => state.wallet.transacations);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(BchatWalletHeader_1.WalletHeader, { clearStates: props.clearStates }),
        react_1.default.createElement(Text_1.SpacerLG, null),
        react_1.default.createElement("div", { className: "wallet-contentSpace" },
            react_1.default.createElement(exports.BalanceAndsendReceiveAction, { clearStates: props.clearStates }),
            react_1.default.createElement(Text_1.SpacerLG, null),
            WalletDashboard.walletSend === focusedInnersection && (react_1.default.createElement(BchatWalletSendForm_1.SendForm, { amount: props.amount, setAmount: props.setAmount, notes: props.notes, setNotes: props.setNotes })),
            WalletDashboard.walletReceived === focusedInnersection && react_1.default.createElement(BchatWalletReceivedForm_1.ReceivedForm, null),
            WalletDashboard.walletTransaction === focusedInnersection && (react_1.default.createElement(BchatWalletTransactionSection_1.TransactionSection, { transactionList: transactions }))),
        react_1.default.createElement("div", { className: 'wallet-syncStatusBox' },
            react_1.default.createElement(BchatWalletSyncSatusBar_1.MemoSyncStatusBar, null))));
};
exports.Dashboard = Dashboard;
const BalanceAndsendReceiveAction = (props) => {
    return (react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "row", justifyContent: "space-between" },
        react_1.default.createElement(BchatWalletBalanceSection_1.WalletBalanceSection, null),
        react_1.default.createElement(BchatWalletPaymentSection_1.WalletPaymentSection, { clearStates: props.clearStates })));
};
exports.BalanceAndsendReceiveAction = BalanceAndsendReceiveAction;
