"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WalletPassword = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const BchatButton_1 = require("../basic/BchatButton");
const Text_1 = require("../basic/Text");
const icon_1 = require("../icon");
const wallet_rpc_1 = require("../../wallet/wallet-rpc");
const settings_key_1 = require("../../data/settings-key");
const walletConfig_1 = require("../../state/ducks/walletConfig");
const BchatWalletForgotPassword_1 = require("./BchatWalletForgotPassword");
const BchatWalletProgressForSync_1 = require("./BchatWalletProgressForSync");
const walletConfig_2 = require("../../state/selectors/walletConfig");
const BchatWalletHelper_1 = require("../../wallet/BchatWalletHelper");
const utils_1 = require("../../bchat/utils");
const data_1 = require("../../data/data");
const utils_2 = require("../../bchat/utils");
const styled_components_1 = __importDefault(require("styled-components"));
const react_use_1 = require("react-use");
const modalDialog_1 = require("../../state/ducks/modalDialog");
const daemon_rpc_1 = require("../../wallet/daemon-rpc");
const WalletPassword = (props) => {
    const [password, setValue] = (0, react_1.useState)('');
    const [forgotPassword, setForgotPassword] = (0, react_1.useState)(false);
    const [loading, setLoading] = (0, react_1.useState)(false);
    const dispatch = (0, react_redux_1.useDispatch)();
    const userId = (0, react_redux_1.useSelector)((state) => state.user.ourNumber);
    const UserDetails = (0, react_redux_1.useSelector)((state) => state.conversations.conversationLookup);
    let currentHeight;
    let daemonHeight;
    const currentDaemon = window.getSettingValue(settings_key_1.walletSettingsKey.settingsCurrentDeamon);
    if (currentDaemon?.type === 'Local') {
        currentHeight = (0, react_redux_1.useSelector)((state) => state.daemon.height);
        daemonHeight = Number((0, react_redux_1.useSelector)(walletConfig_2.getHeight));
    }
    else {
        currentHeight = Number((0, react_redux_1.useSelector)(walletConfig_2.getHeight));
        daemonHeight = (0, react_redux_1.useSelector)((state) => state.daemon.height);
    }
    const Loader = styled_components_1.default.div `
    position: absolute;
    // top: 0;
    display: flex;
    // justify-content: center;
    /* width: 100%; */
    // width: 100Vw;
    // height: 100%;
    align-items: center;
    z-index: 101;
  `;
    let pct = currentHeight == 0 || daemonHeight == 0 ? 0 : ((100 * currentHeight) / daemonHeight).toFixed(0);
    let percentage = pct == 100 && currentHeight < daemonHeight ? 99 : pct;
    function loadDecimal() {
        if (!window.getSettingValue(settings_key_1.walletSettingsKey.settingsDecimal)) {
            let data = '2 - Two (0.00)';
            window.setSettingValue('decimal', data);
            dispatch((0, walletConfig_1.updateDecimalValue)(data));
        }
        else {
            let data = window.getSettingValue(settings_key_1.walletSettingsKey.settingsDecimal);
            dispatch((0, walletConfig_1.updateDecimalValue)(data));
        }
    }
    loadDecimal();
    (0, BchatWalletHelper_1.loadRecipient)();
    (0, BchatWalletHelper_1.loadFiatCurrency)();
    (0, react_use_1.useKey)((event) => {
        if (!forgotPassword && event.key === 'Enter') {
            submit();
        }
        return event.key === 'Enter';
    });
    async function submit() {
        if (!password) {
            return utils_1.ToastUtils.pushToastError('passwordFieldEmpty', window.i18n('passwordFieldEmpty'));
        }
        let userDetails = await (0, data_1.getConversationById)(utils_2.UserUtils.getOurPubKeyStrFromCache());
        let profileName = userDetails?.attributes.walletUserName;
        if (!profileName) {
            profileName = UserDetails[userId].profileName;
        }
        setLoading(true);
        let openWallet = await wallet_rpc_1.wallet.openWallet(profileName, password);
        if (openWallet.hasOwnProperty('error')) {
            setLoading(false);
            return utils_1.ToastUtils.pushToastError('walletInvalidPassword', openWallet.error?.message);
        }
        else {
            wallet_rpc_1.wallet.startHeartbeat('wallet');
            let emptyAddress = '';
            dispatch((0, walletConfig_1.updateSendAddress)(emptyAddress));
            let False = false;
            dispatch((0, walletConfig_1.updateWalletPasswordPopUpFlag)(False));
            dispatch((0, modalDialog_1.updateBchatWalletPasswordModal)(null));
            setLoading(false);
            daemon_rpc_1.daemon.daemonHeartbeat();
        }
    }
    if (forgotPassword) {
        return (react_1.default.createElement(BchatWalletForgotPassword_1.ForgotPassword, { cancelBtn: () => setForgotPassword(false), exit: props.onClickClose }));
    }
    if (daemonHeight > 0 && percentage < 99) {
        return (react_1.default.createElement(BchatWalletProgressForSync_1.ProgressForSync, { remainingHeight: daemonHeight - currentHeight, percentage: percentage, exit: props.onClickClose }));
    }
    return (react_1.default.createElement("div", { className: "wallet-walletPassword" },
        react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox" },
            loading && (react_1.default.createElement(Loader, null,
                react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox-loader" },
                    react_1.default.createElement("img", { src: 'images/bchat/Load_animation.gif', style: { width: '150px', height: '150px' } })))),
            react_1.default.createElement("div", { className: "exitBtn" },
                react_1.default.createElement("article", null,
                    react_1.default.createElement(icon_1.BchatIconButton, { iconType: "exit", iconSize: "small", onClick: props.onClickClose, dataTestId: "modal-close-button" }))),
            react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox-walletImg" }),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox-headerBox" },
                react_1.default.createElement(icon_1.BchatIcon, { iconType: "lock", iconSize: 'small' }),
                react_1.default.createElement("span", null, window.i18n('enterWalletPassword'))),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox-inputBox" },
                react_1.default.createElement("input", { type: "password", autoFocus: true, value: password, onChange: e => setValue(e.target.value) })),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", { className: "wallet-walletPassword-contentBox-forgotTxt" },
                react_1.default.createElement("span", { onClick: () => setForgotPassword(true), style: { cursor: 'pointer' } }, window.i18n('forgotPassword'))),
            react_1.default.createElement(Text_1.SpacerMD, null),
            react_1.default.createElement("div", null,
                react_1.default.createElement(BchatButton_1.BchatButton, { text: window.i18n('continue'), buttonType: BchatButton_1.BchatButtonType.BrandOutline, buttonColor: BchatButton_1.BchatButtonColor.Green, onClick: () => submit() })),
            react_1.default.createElement(Text_1.SpacerLG, null))));
};
exports.WalletPassword = WalletPassword;
