"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BchatButtonIcon = exports.WalletPaymentSection = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const styled_components_1 = __importDefault(require("styled-components"));
const walletInnerSection_1 = require("../../state/ducks/walletInnerSection");
const Flex_1 = require("../basic/Flex");
const BchatIcon_1 = require("../icon/BchatIcon");
const BchatWalletMainPanel_1 = require("./BchatWalletMainPanel");
const WalletPaymentSection = (props) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const focusedInnersection = (0, react_redux_1.useSelector)((state) => state.walletInnerFocused);
    const zoomLevel = window.getSettingValue('zoom-factor-setting');
    function tabBtn() {
        props.clearStates();
        dispatch((0, walletInnerSection_1.walletSendPage)());
    }
    return (react_1.default.createElement("div", { className: "wallet-squarBox-tran", style: zoomLevel > 100 ? { width: '46.4%' } : {} },
        react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "column", justifyContent: "center", height: "100%" },
            react_1.default.createElement("div", null,
                react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "row", justifyContent: "space-between" },
                    react_1.default.createElement(exports.BchatButtonIcon, { name: window.i18n('send'), iconSize: "small", iconType: "paySend", iconColor: BchatWalletMainPanel_1.WalletDashboard.walletSend === focusedInnersection ? '#fff' : '#FC2727', onClick: () => tabBtn(), isSelected: BchatWalletMainPanel_1.WalletDashboard.walletSend === focusedInnersection }),
                    react_1.default.createElement("span", { style: { width: '5%', height: '20px' } }),
                    react_1.default.createElement(exports.BchatButtonIcon, { name: window.i18n('received'), iconSize: "small", iconType: "payRecieved", iconColor: BchatWalletMainPanel_1.WalletDashboard.walletReceived === focusedInnersection ? '#fff' : '#159B24', onClick: () => {
                            dispatch((0, walletInnerSection_1.walletReceivedPage)());
                        }, isSelected: BchatWalletMainPanel_1.WalletDashboard.walletReceived === focusedInnersection }))),
            react_1.default.createElement(Flex_1.Flex, { container: true, flexDirection: "row", justifyContent: "space-between", margin: "15px 0 0 0" },
                react_1.default.createElement(exports.BchatButtonIcon, { name: window.i18n('transactionDetails'), iconSize: "large", iconType: "payTransaction", iconColor: BchatWalletMainPanel_1.WalletDashboard.walletTransaction === focusedInnersection
                        ? '#fff'
                        : 'var(--color-text)', onClick: () => {
                        dispatch((0, walletInnerSection_1.walletTransactionPage)());
                    }, isSelected: BchatWalletMainPanel_1.WalletDashboard.walletTransaction === focusedInnersection })))));
};
exports.WalletPaymentSection = WalletPaymentSection;
const BchatButtonIcon = (props) => {
    return (react_1.default.createElement("div", { onClick: props.onClick, style: { width: '100%' } },
        react_1.default.createElement(Button, { isSelected: props.isSelected },
            react_1.default.createElement(BchatIcon_1.BchatIcon, { iconSize: props.iconSize, iconType: props.iconType, iconColor: props.iconColor }),
            react_1.default.createElement("span", { className: "font-medium", style: { marginLeft: '5px' } }, props.name))));
};
exports.BchatButtonIcon = BchatButtonIcon;
const Button = styled_components_1.default.button `
  outline: none;
  border: none;
  background-color: ${props => props.isSelected ? 'var(--button-color)' : 'var(--color-walTransacBtn)'};
  width: 100%;
  height: 60px;
  border-radius: 10px;
  font-size: 16px;
  color: ${props => (props.isSelected ? '#fff' : '')};

  &:hover {
    background-color : ${props => (props.isSelected ? 'var(--button-color)' : 'var(--color-walletSelectOption)')};;
  }
`;
