"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoSyncStatusBar = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const styled_components_1 = __importDefault(require("styled-components"));
const walletConfig_1 = require("../../state/selectors/walletConfig");
const Flex_1 = require("../basic/Flex");
const walletConfig_2 = require("../../state/ducks/walletConfig");
const settings_key_1 = require("../../data/settings-key");
const SyncStatusBar = (props) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const { from = "" } = props;
    let currentHeight;
    let daemonHeight;
    const currentDaemon = window.getSettingValue(settings_key_1.walletSettingsKey.settingsCurrentDeamon);
    const walletDetails = (0, react_redux_1.useSelector)((state) => state.wallet);
    let decimalValue = window.getSettingValue(settings_key_1.walletSettingsKey.settingsDecimal) || '2 - Two (0.00)';
    decimalValue = decimalValue.charAt(0);
    if (currentDaemon?.type === 'Local') {
        currentHeight = (0, react_redux_1.useSelector)((state) => state.daemon.height);
        daemonHeight = Number((0, react_redux_1.useSelector)(walletConfig_1.getHeight));
    }
    else {
        currentHeight = Number((0, react_redux_1.useSelector)(walletConfig_1.getHeight));
        daemonHeight = (0, react_redux_1.useSelector)((state) => state.daemon.height);
    }
    let pct = currentHeight == 0 || daemonHeight == 0 ? 0 : ((100 * currentHeight) / daemonHeight).toFixed(1);
    let percentage = pct == 100.0 && currentHeight < daemonHeight ? 99.9 : pct;
    const getSyncStatus = window.getSettingValue('syncStatus');
    const syncStatus = getSyncStatus
        ? { color: '#1DBF25', status: 'Synchronized' }
        : { color: '#FDB12A', status: 'Scanning' };
    window.setSettingValue('syncStatus', pct >= 99 ? true : false);
    let value = pct >= 99 ? true : false;
    dispatch((0, walletConfig_2.updateWalletRescaning)(value));
    return (react_1.default.createElement("div", { className: "syncStatus" },
        react_1.default.createElement("div", null,
            from !== "chat" && react_1.default.createElement(Indicator, { style: {
                    width: `${percentage}%`,
                    backgroundColor: syncStatus.color,
                } }),
            react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "space-between", padding: from === "chat" ? "9px 18px" : "5px 15px" },
                react_1.default.createElement(Flex_1.Flex, { container: true },
                    react_1.default.createElement("div", { className: "syncStatus-statusTxt" },
                        "Status :",
                        ' ',
                        react_1.default.createElement("span", { className: "syncStatus-statusTxt-greenTxt", style: { color: syncStatus.color } }, syncStatus.status))),
                react_1.default.createElement(Flex_1.Flex, { container: true },
                    from == "chat" && react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement("div", { className: (walletDetails.balance / 1e9) > 0 ? "syncStatus-balance" : 'syncStatus-disableBalance' },
                            "Balance : ",
                            react_1.default.createElement("span", { className: 'syncStatus-disableBalance' }, (walletDetails.balance / 1e9).toFixed(decimalValue))),
                        react_1.default.createElement("div", { className: (walletDetails.balance / 1e9) > 0 ? "syncStatus-unlocked-Balance" : 'syncStatus-disableBalance', style: { marginLeft: '10px' } },
                            "Unlocked Balance : ",
                            react_1.default.createElement("span", { className: 'syncStatus-disableBalance' },
                                " ",
                                (walletDetails.unlocked_balance / 1e9).toFixed(decimalValue)))),
                    react_1.default.createElement("div", { style: { marginLeft: '10px' }, className: "syncStatus-statusvalue" },
                        window.getSettingValue('current-deamon')?.type,
                        " : ",
                        daemonHeight),
                    react_1.default.createElement("div", { className: "syncStatus-statusvalue", style: { marginLeft: '10px' } },
                        "Wallet : ",
                        currentHeight,
                        " / ",
                        daemonHeight,
                        " (",
                        percentage,
                        "%)"))),
            from == "chat" && react_1.default.createElement(Indicator, { style: {
                    width: `${percentage}%`,
                    backgroundColor: syncStatus.color,
                } }))));
};
const Indicator = styled_components_1.default.div `
  width: 10%;
  height: 2px;
  background-color: #fdb12a;
  transition: width 3s ease-in-out;
`;
exports.MemoSyncStatusBar = react_1.default.memo(SyncStatusBar);
