"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionSection = void 0;
const classnames_1 = __importDefault(require("classnames"));
const moment_1 = __importDefault(require("moment"));
const react_1 = __importStar(require("react"));
const data_1 = require("../../data/data");
const Flex_1 = require("../basic/Flex");
const Text_1 = require("../basic/Text");
const BchatIcon_1 = require("../icon/BchatIcon");
const electron_1 = require("electron");
const walletConfig_1 = require("../../state/selectors/walletConfig");
const react_redux_1 = require("react-redux");
const TransactionSection = (props) => {
    const transactionsHistory = props.transactionList == undefined ? [] : props.transactionList;
    const [filter, setFilter] = (0, react_1.useState)(window.i18n('filterAll'));
    const [emptyScreen, setEmptyScreen] = (0, react_1.useState)(window.i18n('filterAll'));
    const [visible, setVisible] = (0, react_1.useState)(false);
    const [data, setData] = (0, react_1.useState)(transactionsHistory);
    const [searchData, setSearchData] = (0, react_1.useState)([]);
    const [selected, setSelected] = (0, react_1.useState)(null);
    const [receipientData, setRecipientdata] = (0, react_1.useState)([]);
    const [searchText, setSearchText] = (0, react_1.useState)('');
    const syncStatus = (0, react_redux_1.useSelector)(walletConfig_1.getRescaning);
    const recip = receipientData;
    const zoomLevel = window.getSettingValue('zoom-factor-setting');
    (0, react_1.useEffect)(() => {
        document.removeEventListener('click', handleClick);
        switch (filter) {
            case 'Outgoing':
                filterTransaction('out');
                break;
            case 'Pending':
                filterTransaction('pending');
                break;
            case 'Failed':
                filterTransaction('failed');
                break;
            case 'Incoming':
                filterTransaction('in');
                break;
            default:
                filterTransaction('All');
                break;
        }
        return () => {
            document.removeEventListener('click', handleClick);
        };
    }, [transactionsHistory]);
    const handleClick = (e) => {
        if (!modalRef.current?.contains(e.target)) {
            setVisible(!visible);
        }
    };
    function openToExplore(traxId) {
        if (window.networkType === 'mainnet') {
            void electron_1.shell.openExternal(`http://explorer.beldex.io/tx/${traxId}`);
        }
        else {
            void electron_1.shell.openExternal(`http://154.26.139.105/tx/${traxId}`);
        }
    }
    function closeDropDown(params, type) {
        setFilter(params);
        setEmptyScreen(params);
        setVisible(!visible);
        filterTransaction(type);
    }
    async function showdata(item, i) {
        if (selected === i) {
            setSelected(null);
        }
        else {
            setSelected(i);
        }
        if (item.type !== 'in') {
            let recipientAddress = await (0, data_1.getRecipientAddress)(item.txid);
            setRecipientdata(recipientAddress);
            return;
        }
        setRecipientdata([]);
    }
    const TransactionIndication = (props) => {
        const { type } = props;
        let item = {
            iconType: 'payRecieved',
            iconColor: '#128b17',
            type: window.i18n('received'),
        };
        switch (type) {
            case 'out':
                (item.iconType = 'paySend'),
                    (item.iconColor = '#FC2727'),
                    (item.type = window.i18n('sent'));
                break;
            case 'pending':
                (item.iconType = 'pendingTransaction'),
                    (item.iconColor = '#FDB12A'),
                    (item.type = window.i18n('pending'));
                break;
            case 'failed':
                (item.iconType = 'error'),
                    (item.iconColor = '#FC2727'),
                    (item.type = window.i18n('failed'));
                break;
            default:
                break;
        }
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: item.iconType, iconSize: 'medium', iconColor: item.iconColor }),
            react_1.default.createElement("div", null, item.type)));
    };
    function filterText(value) {
        var letters = /^[0-9a-zA-Z]+\.?\d*$/;
        if (value === '' || value.match(letters)) {
        }
        else {
            return;
        }
        setSearchText(value);
        searchTransaction(searchData);
    }
    function searchTransaction(filteredTransaction) {
        let data = filteredTransaction.length > 0
            ? filteredTransaction.filter((item) => String(item.amount / 1e9).includes(searchText.toLowerCase()) ||
                item.txid.toLowerCase().includes(searchText.toLowerCase()))
            : [];
        setData(data);
    }
    function filterTransaction(filterType) {
        let allTransaction;
        if (filterType === window.i18n('filterAll')) {
            allTransaction = transactionsHistory;
        }
        else {
            allTransaction =
                transactionsHistory.length > 0 &&
                    transactionsHistory.filter((data) => data.type === filterType);
        }
        setSearchData(allTransaction);
        if (searchText) {
            searchTransaction(allTransaction);
        }
        else {
            setData(allTransaction);
        }
    }
    const modalRef = (0, react_1.useRef)(null);
    return (react_1.default.createElement("div", { className: "wallet-Transaction" }, !syncStatus ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "wallet-syncing" }),
        react_1.default.createElement("h5", { className: "wallet-syncing-content" }, window.i18n('walletSyncingDiscription')))) : (react_1.default.createElement("div", { style: { height: '98%' }, onClick: () => (visible ? setVisible(false) : '') },
        react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "space-between", flexDirection: "row" },
            react_1.default.createElement("div", { className: "wallet-Transaction-title" }, window.i18n('transactions')),
            react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "flex-end", flexDirection: "row", width: '77%' },
                transactionsHistory.length !== 0 || searchText ? (react_1.default.createElement("div", null,
                    window.i18n('filter'),
                    react_1.default.createElement("input", { placeholder: window.i18n('filterPlaceHolder'), className: "wallet-Transaction-filterInput", onChange: (e) => filterText(e.target.value), value: searchText }))) : (''),
                transactionsHistory.length > 0 && (react_1.default.createElement("div", { className: "wallet-Transaction-filterWithIcon" },
                    react_1.default.createElement("span", { className: "wallet-Transaction-filterWithIcon-inputBox" }, filter),
                    react_1.default.createElement("span", { onClick: () => setVisible(!visible), style: { cursor: 'pointer' } },
                        react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "filter", iconSize: 'tiny' })),
                    visible && (react_1.default.createElement("div", { style: { position: 'relative' } },
                        react_1.default.createElement("div", { className: "wallet-settings-nodeSetting-sendDropDown" },
                            react_1.default.createElement("div", { className: (0, classnames_1.default)(`dropDownItem `), onClick: () => closeDropDown(window.i18n('filterAll'), 'All') },
                                filter === window.i18n('filterAll') ? (react_1.default.createElement("span", { className: "dropDownItem-blockAndMargin" },
                                    react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "tickCircle", iconColor: "#FFF", iconSize: 13, iconPadding: '3px', backgroundColor: '#159B24', borderRadius: '10px' }))) : (react_1.default.createElement("span", { className: "dropDownItem-checkedCircle" })),
                                window.i18n('filterAll')),
                            react_1.default.createElement("div", { className: (0, classnames_1.default)(`dropDownItem `), onClick: () => closeDropDown(window.i18n('filterIncoming'), 'in') },
                                filter === window.i18n('filterIncoming') ? (react_1.default.createElement("span", { className: "dropDownItem-blockAndMargin" },
                                    react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "tickCircle", iconColor: "#FFF", iconSize: 13, iconPadding: '3px', backgroundColor: '#159B24', borderRadius: '10px' }))) : (react_1.default.createElement("span", { className: "dropDownItem-checkedCircle" })),
                                window.i18n('filterIncoming')),
                            react_1.default.createElement("div", { className: (0, classnames_1.default)(`dropDownItem `), onClick: () => closeDropDown(window.i18n('filterOutgoing'), 'out') },
                                filter === window.i18n('filterOutgoing') ? (react_1.default.createElement("span", { className: "dropDownItem-blockAndMargin" },
                                    react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "tickCircle", iconColor: "#FFF", iconSize: 13, iconPadding: '3px', backgroundColor: '#159B24', borderRadius: '10px' }))) : (react_1.default.createElement("span", { className: "dropDownItem-checkedCircle" })),
                                window.i18n('filterOutgoing')),
                            react_1.default.createElement("div", { className: (0, classnames_1.default)(`dropDownItem `), onClick: () => closeDropDown(window.i18n('filterPending'), 'pending') },
                                filter === window.i18n('filterPending') ? (react_1.default.createElement("span", { className: "dropDownItem-blockAndMargin" },
                                    react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "tickCircle", iconColor: "#FFF", iconSize: 13, iconPadding: '3px', backgroundColor: '#159B24', borderRadius: '10px' }))) : (react_1.default.createElement("span", { className: "dropDownItem-checkedCircle" })),
                                window.i18n('filterPending')),
                            react_1.default.createElement("div", { className: (0, classnames_1.default)(`dropDownItem `), onClick: () => closeDropDown(window.i18n('failed'), 'failed') },
                                filter === window.i18n('failed') ? (react_1.default.createElement("span", { className: "dropDownItem-blockAndMargin" },
                                    react_1.default.createElement(BchatIcon_1.BchatIcon, { iconType: "tickCircle", iconColor: "#FFF", iconSize: 13, iconPadding: '3px', backgroundColor: '#159B24', borderRadius: '10px' }))) : (react_1.default.createElement("span", { className: "dropDownItem-checkedCircle" })),
                                window.i18n('failed'))))))))),
        react_1.default.createElement(Text_1.SpacerLG, null),
        react_1.default.createElement("div", { className: "wallet-Transaction-parentBox" },
            data.length > 0 &&
                data.map((item, i) => (react_1.default.createElement("div", { className: "wallet-Transaction-contentBox", key: i, onClick: () => showdata(item, i), style: { cursor: 'pointer' } },
                    react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: "space-between", flexDirection: "row" },
                        react_1.default.createElement(Flex_1.Flex, { container: true, height: " 60px", width: "66%" },
                            react_1.default.createElement("article", { className: "wallet-Transaction-contentBox-sendIndicationBox" },
                                react_1.default.createElement(TransactionIndication, { type: item.type })),
                            react_1.default.createElement("article", { className: "wallet-Transaction-contentBox-verticalline" }),
                            react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-balanceBox", style: { width: zoomLevel > 100 ? '44%' : '' } },
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-balanceBox-amount" },
                                    item.type === 'out' ? '-' : '',
                                    Number((item.amount / 1e9).toFixed(4)),
                                    " BDX"),
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-balanceBox-address", onClick: () => openToExplore(item.txid) }, item.txid))),
                        react_1.default.createElement(Flex_1.Flex, null,
                            react_1.default.createElement("section", { className: "wallet-Transaction-contentBox-dateandheight" },
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-dateandheight-month", style: { marginBottom: '7px' } }, moment_1.default.unix(item.timestamp).fromNow()),
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-dateandheight-height" },
                                    "Height : ",
                                    item.height,
                                    ' ',
                                    item.type === 'out' || item.type === 'in' ? '(confirmed)' : '')))),
                    selected === i && (react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(Flex_1.Flex, { container: true, justifyContent: recip.address && zoomLevel <= 100 ? 'space-between' : 'flex-start', flexDirection: "row", width: '100%' },
                            react_1.default.createElement(Flex_1.Flex, { container: true },
                                react_1.default.createElement("article", { style: recip.address && zoomLevel > 100
                                        ? { width: '122px' }
                                        : { width: '110px' } }),
                                recip.address && (react_1.default.createElement("div", { style: { marginLeft: '20px', width: zoomLevel > 100 ? '44%' : '57%' }, className: "wallet-Transaction-recipitentBox-adddressBox" },
                                    react_1.default.createElement("div", { className: "" }, window.i18n('recipientAddress')),
                                    react_1.default.createElement("div", { className: "wallet-Transaction-recipitentBox-adddressBox-address" }, recip.address))),
                                react_1.default.createElement("section", { style: { marginLeft: '20px' } },
                                    react_1.default.createElement("article", { className: "wallet-Transaction-recipitentBox-transactionFee-header" }, window.i18n('transactionFee')),
                                    react_1.default.createElement("article", { className: "wallet-Transaction-recipitentBox-transactionFee-text" },
                                        item.fee / 1e9,
                                        " BDX"))),
                            react_1.default.createElement("section", { style: {
                                    width: zoomLevel > 100 ? '40%' : '209px',
                                    marginLeft: zoomLevel && recip.address > 100 ? '20px' : '20px',
                                    paddingTop: 0,
                                } },
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-dateandheight-month" }, window.i18n('dateTime')),
                                react_1.default.createElement("div", { className: "wallet-Transaction-contentBox-dateandheight-height" }, moment_1.default.unix(item.timestamp).format('DD/MM/YYYY HH:mm'))))))))),
            data.length == 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: "wallet-Transaction-empty-parentBox" },
                    react_1.default.createElement("div", { className: `wallet-Transaction-${emptyScreen.toLocaleLowerCase()}` }),
                    react_1.default.createElement("h4", { className: "wallet-Transaction-content" }, emptyScreen == 'All' ? (react_1.default.createElement("div", null,
                        window.i18n('emptyTransaction'),
                        !searchText && (react_1.default.createElement("h5", { className: "wallet-Transaction-content-subContent", style: { marginTop: '5px' } }, window.i18n('emptyTransactionDiscription'))))) : emptyScreen == 'imcoming' ? (window.i18n('noIncomingTransaction')) : emptyScreen == 'search' ? (window.i18n('searchEmptyTransaction')) : emptyScreen == 'Outgoing' ? (window.i18n('noOutgoingTransaction')) : emptyScreen == 'Pending' ? (window.i18n('noPendingTransaction')) : (window.i18n('noFailedTransaction')))))) : ('')),
        zoomLevel > 100 && react_1.default.createElement(Text_1.SpacerLG, null)))));
};
exports.TransactionSection = TransactionSection;
