"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEmojiSizeClass = void 0;
function getRegexUnicodeEmojis() {
    return /\p{Emoji_Presentation}/gu;
}
function getCountOfAllMatches(str) {
    const regex = getRegexUnicodeEmojis();
    const matches = str.match(regex);
    return matches?.length || 0;
}
function hasNormalCharacters(str) {
    const noEmoji = str.replace(getRegexUnicodeEmojis(), '').trim();
    return noEmoji.length > 0;
}
function getEmojiSizeClass(str) {
    if (!str || !str.length) {
        return 'small';
    }
    if (hasNormalCharacters(str)) {
        return 'small';
    }
    const emojiCount = getCountOfAllMatches(str);
    if (emojiCount > 6) {
        return 'small';
    }
    else if (emojiCount > 4) {
        return 'medium';
    }
    else if (emojiCount > 2) {
        return 'large';
    }
    else {
        return 'jumbo';
    }
}
exports.getEmojiSizeClass = getEmojiSizeClass;
